//DDrawSetup.cpp: Create window & directDraw setup and release
//Daniel CopyRight Reserved December, 5, 2001


//system includes
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>

//custom includes
#include "Glvar.h"
#include "resource.h"

extern debugID;

//----------------------------------------------------------------------------------
//b Direct Draw 󤺬U Surface tmLŶAöǦ^ӦL
BOOL CreatePalette(LPDIRECTDRAW lpDdObj, LPDIRECTDRAWSURFACE lpSurface, LPDIRECTDRAWPALETTE *lpSurfacePalPtr)
{
  //tmLŶ
  PALETTEENTRY pe[GameCOLORS]; // COLORS wqb Glvar.h  

  //NLƪlơA] ¦ (R=G=B=0)
  for(int i=0; i<GameCOLORS; i++) pe[i].peRed=pe[i].peGreen=pe[i].peBlue=0;

  //b Direct Draw 󤺬ǶiSurfacetmsLŶAñN}sbǶiL
  if(FAILED(lpDdObj->CreatePalette(DDPCAPS_8BIT,pe,lpSurfacePalPtr,NULL)))
    return NULL;

  //N lpSurfacePalettePtr ҦsL} Assign  lpSurface
  lpSurface->SetPalette((*lpSurfacePalPtr));

  return true;
 
} //CreatePalette


//----------------------------------------------------------------------------------
//إ DirectDraw 
BOOL CreateDirectDraw(HWND hwnd, LPDIRECTDRAW *lpDdObjPtr, unsigned short DisplayW, 
					  unsigned short DisplayH, unsigned char ColorDepth)
{
  //إ DirectDraw  (sVGA Card)
  if(FAILED(DirectDrawCreate(NULL,lpDdObjPtr,NULL)))
    return FALSE;

#ifdef FULLSCREEN_DEBUG
  if(FAILED((*lpDdObjPtr)->SetCooperativeLevel(hwnd, DDSCL_NORMAL))) 
	  return FALSE;
#else
    //]ww骺sv WҦBù
  if(FAILED((*lpDdObjPtr)->SetCooperativeLevel(hwnd, DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN)))
    return FALSE;

  //ܿùѪR
  if(FAILED((*lpDdObjPtr)->SetDisplayMode(DisplayW,DisplayH,ColorDepth)))
    return FALSE;

#endif
  
  return TRUE;
}


//----------------------------------------------------------------------------------
//b DirectDraw  tm Flip Surfaces Ŷ, ΦLŶ
BOOL CreateFlipSurfaces(HWND hwnd, LPDIRECTDRAW lpDdObj, 
						LPDIRECTDRAWSURFACE *lpPriSrfPtr, LPDIRECTDRAWPALETTE *lpPriPalPtr,
						LPDIRECTDRAWSURFACE *lpSecSrfPtr, LPDIRECTDRAWPALETTE *lpSecPalPtr)
{

  //tm Primary Surface Ŷ---------------------------------------------------
  DDSURFACEDESC ddsd; //direct draw surface descriptor
  
#ifdef FULLSCREEN_DEBUG
  ddsd.dwSize	= sizeof(ddsd);
  ddsd.dwFlags = DDSD_CAPS ;
  ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
  
  //tm Primary Surface Ŷ
  if(FAILED(lpDdObj->CreateSurface(&ddsd,lpPriSrfPtr,NULL)))
    return FALSE;  	
  //tm Primary Surface LŶ
  CreatePalette(lpDdObj, *lpPriSrfPtr, lpPriPalPtr);


  ddsd.dwFlags	= DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH;

  //]wª Surface  Flip  Alpha Blend 
  ddsd.ddsCaps.dwCaps	= DDSCAPS_OFFSCREENPLAIN|DDSCAPS_SYSTEMMEMORY;
  
  //]wSurfacee
  ddsd.dwHeight	= SCREEN_HEIGHT; 
  ddsd.dwWidth	= SCREEN_WIDTH;

  //tm Background Surface Ŷ
  if(FAILED(lpDdObj->CreateSurface(&ddsd,lpSecSrfPtr,NULL)))
    return FALSE;
  //tm Seccondary Surface L
  CreatePalette(lpDdObj, *lpSecSrfPtr, lpSecPalPtr);  

#else
  ddsd.dwSize=sizeof(ddsd);
  //\]w Back Buffer ƥ
  ddsd.dwFlags=DDSD_CAPS|DDSD_BACKBUFFERCOUNT; 
  //]w ֦Pirmary SurfaceAi FlipAh Surface
  ddsd.ddsCaps.dwCaps=DDSCAPS_PRIMARYSURFACE|DDSCAPS_FLIP|DDSCAPS_COMPLEX;
  //]wu@ BackBufferAY Secondary Surface
  ddsd.dwBackBufferCount=1;


  //tm Primary Surface ŶAñN lpPriSurface ЫVOа
  if(FAILED(lpDdObj->CreateSurface(&ddsd,lpPriSrfPtr,NULL)))
    return FALSE;

  //tm Primary Surface LŶ
  CreatePalette(lpDdObj, *lpPriSrfPtr, lpPriPalPtr);
 

   //̫tm Secondary Surface Ŷ---------------------------------------------------
  DDSCAPS ddscaps;
  ddscaps.dwCaps=DDSCAPS_BACKBUFFER;
  //QPrimary Surface  GetAttachedSurface tm Secondary Surface ŶA
  //ñN lpSecSurface V
  if(FAILED((*lpPriSrfPtr)->GetAttachedSurface(&ddscaps,lpSecSrfPtr)))
    return FALSE;

  //tm Seccondary Surface L
  CreatePalette(lpDdObj, *lpSecSrfPtr, lpSecPalPtr);  


#endif

  /*
  //ǳƦb Secondary Surface إ direct draw clipper-----------------------------------------------------
  //إ߫ASurface ~iHϥ Blt (iClip)BBltBatchBUpdateOverlayC
  LPDIRECTDRAWCLIPPER lpClipper; //pointer to the clipper
  //tmtm direct draw clipper Ŷ
  if(FAILED(lpDdObj->CreateClipper(NULL,&lpClipper,NULL)))
    return FALSE;
  //]w Clipped ƪ Window Handle
  if(FAILED(lpClipper->SetHWnd(NULL,hwnd)))
    return FALSE;
  //N Clipper  attach  secondary surface,  Secondary Surface iH Clipper 
  if(FAILED((*lpSecSrfPtr)->SetClipper(lpClipper)))
    return FALSE;
  */

  return TRUE;
}





//----------------------------------------------------------------------------------
//l DirectDraw Atm Surface OЪŶ
BOOL CreateSystemSurfaces(bool SetClipper, HWND hwnd, LPDIRECTDRAW lpDdObj, LPDIRECTDRAWSURFACE *lpSrfPtr, 
						   int W, int H)
{ 
  DDSURFACEDESC ddsd; //direct draw surface descriptor 

  
  //إDirectDraw 󪺥t~@ OffScreen Surface:  Message Window surface-------------------
  ddsd.dwSize	= sizeof(ddsd);
  ddsd.dwFlags	= DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH;

  //]wª Surface  Flip  Alpha Blend 
  ddsd.ddsCaps.dwCaps	= DDSCAPS_OFFSCREENPLAIN|DDSCAPS_SYSTEMMEMORY ;
  
  //]wSurfacee
  ddsd.dwHeight	= H; 
  ddsd.dwWidth	= W;

  //tm Background Surface Ŷ
  if(FAILED(lpDdObj->CreateSurface(&ddsd,lpSrfPtr,NULL)))
    return FALSE;  

  DDCOLORKEY ddck; //direct draw color descriptor
  ddck.dwColorSpaceLowValue= ddck.dwColorSpaceHighValue=TRANSPARENT_COLOR; //one color

  //]wz ]ϥ AlphaBlend ҥH]wzNL
  (*lpSrfPtr)->SetColorKey(DDCKEY_SRCBLT,&ddck);


  if(SetClipper)
  {
	//ǳƦb Secondary Surface إ direct draw clipper-----------------------------------------------------
	//إ߫ASurface ~iHϥ Blt (iClip)BBltBatchBUpdateOverlayC
	LPDIRECTDRAWCLIPPER lpClipper; //pointer to the clipper
	//tmtm direct draw clipper Ŷ
	if(FAILED(lpDdObj->CreateClipper(NULL,&lpClipper,NULL)))
	    return FALSE;
	//]w Clipped ƪ Window Handle
	if(FAILED(lpClipper->SetHWnd(NULL,hwnd)))
	    return FALSE;
	//N Clipper  attach  secondary surface,  Secondary Surface iH Clipper 
	if(FAILED((*lpSrfPtr)->SetClipper(lpClipper)))
	    return FALSE;
  }
  
  
  return TRUE;
} //InitDirectDraw


//----------------------------------------------------------------------------------
//ŧi CallBack 
long CALLBACK WindowProc(HWND hwnd,UINT message, WPARAM wParam,LPARAM lParam);


//----------------------------------------------------------------------------------
//إ߹w] Window
HWND CreateDefaultWindow(char* name,HINSTANCE hInstance)
{
  WNDCLASS wc; //window registration info
  //register display window
  wc.style=CS_HREDRAW|CS_VREDRAW; //style
  wc.lpfnWndProc=WindowProc; //window message handler
  wc.cbClsExtra=wc.cbWndExtra=0;
  wc.hInstance=hInstance;
  wc.hIcon=LoadIcon(hInstance,MAKEINTRESOURCE(ID_DANIEL));//IDI_APPLICATION);
  wc.hCursor=LoadCursor(NULL,IDC_ARROW);
  wc.hbrBackground=(HBRUSH) (COLOR_WINDOW + 1);//(HBRUSH)GetStockObject(BLACK_BRUSH);//NULL;
  wc.lpszMenuName=NULL;
  wc.lpszClassName=name;
  RegisterClass(&wc);

  
  //create and set up fullscreen window
  
#ifdef FULLSCREEN_DEBUG
  return CreateWindowEx(
		0,
		name,
		name,
		WS_OVERLAPPEDWINDOW|WS_THICKFRAME,
		0,//(GetSystemMetrics(SM_CXFULLSCREEN)-325)/2,
		0,//(GetSystemMetrics(SM_CYFULLSCREEN)-260)/2,
		SCREEN_WIDTH,
		SCREEN_HEIGHT,
		NULL,
		NULL,
		hInstance,
		NULL );

#else
  return CreateWindowEx(
		0,
		name,
		name,
		WS_POPUP,
		0,0,
		GetSystemMetrics(SM_CXSCREEN),
		GetSystemMetrics(SM_CYSCREEN),
		NULL,
		NULL,
		hInstance,
		NULL );
#endif
}




