//main.cpp
//Daniel CopyRight Reserved December, 5, 2001


//\G
//1) ϥΨ Surface Ӱ Flip, 1  SystemMemory Surface  Compose new frameC
//2) Pre-built Alpha Table for Quick Alpha Blending.
//3) pre-built BlurTable for quick Blur.



#define MAIN
//system includes----------------------------------------------------------------
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>
#include <stdio.h>
#include <math.h>


//system defines---------------------------------------------------------------------
#define WIN32_LEAN_AND_MEAN

//custom includes
#include "Glvar.h" //global definitions
#include "bmp.h" //bmp file reader
#include "timer.h" //game timer
#include "WorldSystem.h"
#include "Random.h"
#include "Sprite.h"
#include "Object.h"
#include "Font.h"
#include "ddrawUtil.h"
#include "Effect.h"
#include "Palette.h"


//ۭqTƪ HWֳt----------------------------------------------
#define degrees 256
float SinTable[degrees], CosTable[degrees]; //360 
//#define SIN(x) SinTable[abs((int)x&359)]
//#define COS(x) CosTable[abs((int)x&359)]
//l SIN, COS table------------------------------------------------
void Init_CosSinTable()
{
   int d;
   for(d=0; d<degrees; d++)
   {
       SinTable[d]=float(sin(d/(degrees/2.0)*pi));
       CosTable[d]=float(cos(d/(degrees/2.0)*pi));
   }
}

float SIN(short deg)
{
	return SinTable[abs((short)deg&(degrees-1))];
}

float COS(short deg) 
{
	return CosTable[abs((short)deg&(degrees-1))];
}




//----------------------------------------------------------------------------------
//Global ܼ
   
BOOL ActiveApp;		//{O_ Activated

//ŧi DirectDraw MΨӰ Flip  Primary Surface M Secondary Surface
LPDIRECTDRAW lpDdObject=NULL;			//direct draw object
LPDIRECTDRAWSURFACE lpPriSurface=NULL;	//primary surface
LPDIRECTDRAWPALETTE lpPriPalette;		//its palette
LPDIRECTDRAWSURFACE lpSecSurface=NULL;	//back buffer (secondary surface)
LPDIRECTDRAWPALETTE lpSecPalette;		//its palette

//ŧi Ҧ CBmpFileReader OAΨŪJɨñNϧθƩbtΰOаϤ
CBmpFileReader ImgMsgWnd;
CBmpSpriteFileReader  ImgBackground, ImgSprites;

//ŧi Surface ΨӦs ( btΰO餺 ) ҦŪiӪϧθ
LPDIRECTDRAWSURFACE lpMsgSurface=NULL;	//T
LPDIRECTDRAWSURFACE lpSecBuffer=NULL;

//xsϪejp
//int *bkgW,*bkgH,*bkgX,*bkgY;

enum Arrow{LFT,RHT,UP,DN};
bool ArrowKeyDown[4]={false,false,false,false}; //0:left, 1:right, 2:top, 3:bottom
const int TreeNum=50, MonsterNum=50;

CTimer Timer;		//pɾ
CRandom Random;		//üƲ;
CWorld2D GameWorld;	//C@O
CSprite SpriteGirl, SpriteMonster[corner315+1];
CAlphaSprite AlphaSpriteGirl(128);
CStillObject ObjTree[TreeNum];
CWiseObject Monster[MonsterNum];
CPlayerObject Player;

CFire Fire;

unsigned char AlphaTable[256][256];

//ŧi@ FONT c
CDdFont SurfaceFnt(10);

//ùjp RECT 
RECT ScreenRECT;
HWND hwnd; //handle to fullscreen window


//eʳt
int PanVec, Vx,Vy, 
	AccelerateTp=0, dVec=5, //Player [tҦG0:[tA1:[tA-1:tC
	FramePeriod=1000/24; //C 24i
unsigned char FadeType=0;
bool ShowParticle=false;
PALETTEENTRY ParticlePalette[256];
unsigned char BlurTable[256*8];



//Debug Variable
int hitX, hitY, debugID=0;
unsigned char DrawID=0;
bool ShowDebugInfo=false, ShowAlphaBlend=true, ShowSurfaces=false;


//Function defines------------------------------------------------------------------------
//{Ab DDrawSetup.cpp 

BOOL CreateDirectDraw(HWND hwnd, LPDIRECTDRAW *lpDdObjPtr, unsigned short DisplayW, 
					  unsigned short DisplayH, unsigned char ColorDepth);

BOOL CreateFlipSurfaces(HWND hwnd, LPDIRECTDRAW lpDdObj, 
						LPDIRECTDRAWSURFACE *lpPriSrfPtr, LPDIRECTDRAWPALETTE *lpPriPalPtr,
						LPDIRECTDRAWSURFACE *lpSecSrfPtr, LPDIRECTDRAWPALETTE *lpSecPalPtr);

BOOL CreateSystemSurfaces(bool SetClipper, HWND hwnd, LPDIRECTDRAW lpDdObj, LPDIRECTDRAWSURFACE *lpSrfPtr, int W, int H);
HWND CreateDefaultWindow(char* name,HINSTANCE hInstance);
void ShowMsgWindow(LPDIRECTDRAWSURFACE lpSurface, int x, int y, char *str, unsigned char alpha);






//*****************************************************************************************
//********************	ư	***********************************************************
//*****************************************************************************************


//----------------------------------------------------------------------------------------
//lƩҦܼ -------------------------------------------------------------------------
void InitialVariable()
{
	ActiveApp=true;		//{O_ Activated

	//ŧi DirectDraw MΨӰ Flip  Primary Surface M Secondary Surface
	lpDdObject = NULL;
	lpPriSurface = lpSecSurface = NULL;	
	lpPriPalette = lpSecPalette = NULL;	

	//ŧi OffScreen Surface : ΨӦs ( btΰO餺 ) ҦŪiӪϧθ
	lpMsgSurface = NULL;	
	lpSecBuffer	 = NULL;

	for (int i=LFT; i<=DN; i++) ArrowKeyDown[i]=false; //0:left, 1:right, 2:top, 3:bottom

	PanVec=5; Vx=0; Vy=0;	
	
	ScreenRECT.left=ScreenRECT.top=0;
	ScreenRECT.right=SCREEN_WIDTH-1; ScreenRECT.bottom=SCREEN_HEIGHT-1;
}



//----------------------------------------------------------------------------------------
//ŪJɨñNɸƶJ BmpFileReader--------------------------------
BOOL LoadImages()
{ 
  //ŪJI
  if(!ImgBackground.load("bckgnd.bmp"))return FALSE;  

  //ŪJSprite 
  if(!ImgSprites.load("Sprites.bmp"))return FALSE;  

  //ŪJmsgWindow
  if(!ImgMsgWnd.load("MsgWnd.bmp"))return FALSE;     
    
  return TRUE;
} 






//b 256 Lo۪񪺭--------------------------------------------------------------
unsigned char Get_NearColor(PALETTEENTRY *pe, unsigned char r,unsigned char g,unsigned char b)
{
	short curdelta=255, mindelta=256;
	unsigned char rr,rg,rb,dr,dg,db, res;

	for(int i=0; i<256; i++)
	{		
		rr=pe[i].peRed;
		rg=pe[i].peGreen;
		rb=pe[i].peBlue;

		//LU⪽MǤJU⪽t
		dr=(rr>r)?rr-r:r-rr;
		dg=(rg>g)?rg-g:g-rg;
		db=(rb>b)?rb-b:b-rb;

		curdelta=dr+dg+db;

		if(curdelta==0)//pGStȪܧ@Ҥ@˪C
		{
			res=i; return res;
		}
		
		//tȳ̤p

		if(curdelta<mindelta)
		{
			mindelta=curdelta;
			res=i;
		}
	}

	return res;
}


//إ 50% Alpha Table----------------------------------------------------------------
BOOL CreateAlphaTable(LPDIRECTDRAWPALETTE lpPal)
{
	if (!lpPal) return FALSE;

	PALETTEENTRY peAry[256], color1, color2;	
	
	lpPal->GetEntries(0, 0, 256, peAry);

	short i,j;
	unsigned char newR,newG,newB;


	for(i=0; i<256; i++)
	for(j=0; j<256; j++) //jGӷLID
	{
		color1=peAry[j]; //jGӷLID
		color2=peAry[i];

		//D 50% Alpha ȡG(color1.r+color2.r)/2, g,b C /2 iΦ줸B ">>1" N
		newR=(color1.peRed	 +color2.peRed	)>>1;
		newG=(color1.peGreen +color2.peGreen)>>1;
		newB=(color1.peBlue  +color2.peBlue	)>>1;	
		
		AlphaTable[j][i]=Get_NearColor(peAry, newR,newG,newB);
	}
	
	return TRUE;
}



//---------------------------------------------------------------------------------------
//eҦ offScreen (D Flip Ϊ) Surface, έ]Ҧ Flip Screen  L.-------
BOOL DrawImageToSurfaces()
{  
  //ھ Imgbackground ϧθƫإ World ðtm  Surface Ŷ------------------------------------
  int WorldWH=SCREEN_WIDTH*10;  
  if(!GameWorld.RandomCreate(&ImgBackground, WorldWH, WorldWH)) return FALSE;

  if(!SpriteGirl.CreateSprite(&ImgSprites, 1,1,5,90,100))return FALSE;
  if(!AlphaSpriteGirl.CreateSprite(&ImgSprites, 1,1,5,90,100))return FALSE;

  
  if(!SpriteMonster[center]		.CreateSprite(&ImgSprites,301,203,3,49,49))return FALSE;
  if(!SpriteMonster[left]		.CreateSprite(&ImgSprites,1,103,3,49,49))return FALSE;
  if(!SpriteMonster[right]		.CreateSprite(&ImgSprites,151,103,3,49,49))return FALSE;
  if(!SpriteMonster[top]		.CreateSprite(&ImgSprites,301,103,3,49,49))return FALSE;
  if(!SpriteMonster[bottom]		.CreateSprite(&ImgSprites,1,153,3,49,49))return FALSE;
  if(!SpriteMonster[corner45]	.CreateSprite(&ImgSprites,151,153,3,49,49))return FALSE;
  if(!SpriteMonster[corner135]	.CreateSprite(&ImgSprites,301,153,3,49,49))return FALSE;
  if(!SpriteMonster[corner225]	.CreateSprite(&ImgSprites,1,203,3,49,49))return FALSE;
  if(!SpriteMonster[corner315]	.CreateSprite(&ImgSprites,151,203,3,49,49))return FALSE;

  //]wǳưܥΪ Surface LơC
  if(!ImgBackground.setSurfacePalette(lpPriPalette))return FALSE;
  if(!ImgBackground.setSurfacePalette(lpSecPalette))return FALSE;

  //] lpBkgSurfaceFlipܥΡAҥHݦL
  //]ɭԷ|զ@i㪺ϵeJ Secondary SurfaceAMA Flip  Primary SurfaceA
  //ҥHbeJ lpPriSurface M lpSecSurfaceC

  //e Backgound Surface;
  if(!ImgMsgWnd.draw2Surface(lpMsgSurface)) return FALSE;

  return TRUE;
}



//---------------------------------------------------------------------------------------
//eҦ offScreen (D Flip Ϊ) Surface
BOOL RestoreSurfaces()
{ 
	BOOL result=TRUE;   

	//Video Memory  Surfaces |H Alt+Tab  lost AҥH Restore;
	if(SUCCEEDED(lpPriSurface->Restore()))
		result=TRUE;

	if(SUCCEEDED(lpSecSurface->Restore()))
		result=TRUE;

	result=result&&SpriteGirl.RestoreSurfaces();
	result=result&&AlphaSpriteGirl.RestoreSurfaces();	

	result=result&&SpriteMonster[center].RestoreSurfaces()&&
			SpriteMonster[left].RestoreSurfaces()&&
			SpriteMonster[right].RestoreSurfaces()&&
			SpriteMonster[top].RestoreSurfaces()&&
			SpriteMonster[bottom].RestoreSurfaces()&&
			SpriteMonster[corner45].RestoreSurfaces()&&
			SpriteMonster[corner135].RestoreSurfaces()&&
			SpriteMonster[corner225].RestoreSurfaces()&&
			SpriteMonster[corner315].RestoreSurfaces();


	/*// SystemMemory  Surface |H Alt+Tab lost AҥH Restore;
	if(SUCCEEDED(lpSecBuffer->Restore()))
		result=TRUE;

	//e message Window Surface
	if(SUCCEEDED(lpMsgSurface->Restore()))
	    result=result&&ImgMsgWnd.draw2Surface(lpMsgSurface); //redraw image
		//result=result&&DrawSurfaceEllipse(lpMsgSurface,30,30,20,RGB(255,0,0));
	else return FALSE;

	//e GameWorld Ҧ surfaces
	result=result&&GameWorld.RestoreSurfaces();   
	*/ 
	
	return result;
}


//----------------------------------------------------------------------------------
//]Ҧ Flip Screen  L.-------
BOOL ResotrePalette()
{
	BOOL result=TRUE;

	if(!ShowParticle)
	{
		result=result&&ImgBackground.setSurfacePalette(lpPriPalette);
		result=result&&ImgBackground.setSurfacePalette(lpSecPalette);
	}
	else
	{
		lpPriPalette->SetEntries(0, 0, 256, ParticlePalette);
		lpSecPalette->SetEntries(0, 0, 256, ParticlePalette);
	}	

	return result;
}



BOOL CreateObjects() 
{
	int x, y, frame;
	
	//إ Tree ------------------------------------------------
	for(int i=0; i<TreeNum; i++)
	{
		GameWorld.GetRandomPosInWorld(&x, &y);
		frame=Random.number(0,SpriteGirl.TotalFrames()-1);
		if(!ObjTree[i].Create(&SpriteGirl, x, y, frame, 500)) return FALSE;
	}

	
	//إ Monster ------------------------------------------------	
	CSprite *sp[corner315+1];
    for(i=center; i<=corner315; i++) sp[i]=&(SpriteMonster[i]);

	for(i=0; i<MonsterNum; i++)
	{		
		GameWorld.GetRandomPosInWorld(&x, &y);
		frame=Random.number(0,SpriteMonster[center].TotalFrames()-1);
		if(!Monster[i].Create(sp, x, y, frame, Random.number(300,1000), 
			Random.Sign()*Random.number(100,800),
			Random.Sign()*Random.number(100,800))) return FALSE;
		//if(!Monster[i].Create(sp, x, y, frame, Random.number(300,1000), 0,0)) return FALSE;
	}

	//إߥD----------------------------------------------------------
	GameWorld.GetRandomPosInWorld(&x, &y);
	frame=Random.number(0,SpriteMonster[center].TotalFrames()-1);
	if(!Player.Create(sp, x, y, frame, 500, Random.Sign()*200, Random.Sign()*200)) return FALSE;
	else GameWorld.SetViewPoint(x,y); 


	//إߤlt--------------------------------------------------
	x=GameWorld.ViewX;
	y=GameWorld.ViewY;

	Fire.Create(x, y, 10, 2000);


	//إߨL---------------------------------------------------

	return TRUE;
}



//---------------------------------------------------------------------------------------
//Debug Function-------------------------------------------------------------------------
void DrawDebugInfo(LPDIRECTDRAWSURFACE lpSurface)
{	
  if(!ShowParticle)
  {
	if (ShowSurfaces)
	{		
		/*//e World Map  lpSurface-------------------------------------------------
		int mx=SCREEN_WIDTH/2-GameWorld.WorldToMapX(GameWorld.ViewX),
			my=SCREEN_HEIGHT/2-GameWorld.WorldToMapY(GameWorld.ViewY);
		if(GameWorld.ShowMap) GameWorld.DrawMap2Surface(lpSurface, mx, my);*/

		/*//--------------Draw lpMsgSurface to lpSurface--------------------------
		RECT rect;	
		rect.left=200; rect.top=0;
		rect.right=rect.left+ImgMsgWnd.ImageWidth(); 
		rect.bottom=rect.top+ImgMsgWnd.ImageHeight();
		ImgMsgWnd.AlphaDraw2Surface(lpMsgSurface, PanVec);
		lpSurface->Blt(&rect,lpMsgSurface,NULL,DDBLT_KEYSRC|DDBLT_WAIT,NULL); */
		
		
		//--------------Draw SpriteGirl Surface to lpSurface--------------------------
		int x,y;	
		x=(SCREEN_WIDTH-90)/2; y=SCREEN_HEIGHT/2-100;	
		static int last_time=Timer.time(), frame=0;
		
		switch(DrawID)
		{
			case 0:
				AlphaSpriteGirl.Draw2Surface(lpSurface,x, y, frame); break;
			case 1:
				SpriteGirl.AlphaDraw2Surface(lpSurface,x,y,frame); break;
			default: break;
		}
		
		if(Timer.timeElapsed(last_time, 200))
		{
		  frame++;
		  frame=(frame>4)?0:frame;
		}		

		/*//-------------Draw ImgBackground to lpSurface----------------------------
		ImgBackground.draw2Surface(lpSurface,bkgW,bkgH,bkgX,bkgY); */	
	}


	if (ShowAlphaBlend) 
	{
		//--------------for Alpha Blend Test--------------------------
		/*//ܰT-------------------------------------------------------------------------
		ShowMsgWindow(lpSurface, 400,5,"Alpha Window Test.", 150);*/

		
		/*//e World Map  lpSurface-------------------------------------------------
		int mx=SCREEN_WIDTH/2-GameWorld.WorldToMapX(GameWorld.ViewX),
			my=SCREEN_HEIGHT/2-GameWorld.WorldToMapY(GameWorld.ViewY);
		GameWorld.BlendDrawMap2Surface(lpSurface,mx,my);		*/
	}

	

	if (ShowDebugInfo)
	{
		// Debug TAWr-----------------------	
		char s[50], bkg[9][10]={"center","left", "right", "top", "bottom","corner45",
								"corner135","corner225", "corner315"};
		int cx,cy, dy;
		short curRow,curCol;

		memset(s,0,50);
		dy=5;
	
		cx = GameWorld.ScreenToWorldX(SCREEN_WIDTH/2);
		cy = GameWorld.ScreenToWorldY(SCREEN_HEIGHT/2);
		curRow=GameWorld.RowOfXY(cy); 
		curCol=GameWorld.ColOfXY(cx);

		memset(s,0,29);

		// World T
		sprintf(s,"R:%-3d C:%-3d (%5d,%5d) - RN:%-3d CN:%-3d" , curRow, curCol, cx,cy, 
			GameWorld.WorldRowNum(), GameWorld.WorldColNum());
		SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(0,255,255),lpSurface);
	 
		RowRec r=GameWorld.StartEndColInRow(curRow);
		sprintf(s,"curCol:%3d ~ %-3d" , r.startCol, r.endCol);
		SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(0,255,255),lpSurface);
		
		//ܥثet
		sprintf(s,"Vec:%-3d" ,PanVec);
		SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(255,0,0),lpSurface);

		/*// bkgX, bkgY, bkgW, bkgH
		sprintf(s,"bkg:  x:%-4d y:%-4d w:%-4d h:%-4d" ,bkgX, bkgY,bkgW,bkgH);
		SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(0,255,0),lpSurface);

		//bkgX,bkgY, bkgW,bkgH
		for (i=center; i<=corner315; i++)
		{
			sprintf(s,"%-7s:  x:%-4d y:%-4d w:%-4d h:%-4d" ,bkg[i], bkgX[i], bkgY[i], bkgW[i], bkgH[i]);
			SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(255,0,125),lpSurface);
		}*/


		//ܼI hitX, hitY
		sprintf(s,"Hit: %3d, %3d,  View: %3d, %3d" ,hitX,hitY,GameWorld.ViewX,GameWorld.ViewY);
		SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(255,0,0),lpSurface);

		// debugID
		sprintf(s,"debugID:%-3d" , debugID);
		SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(0,255,255),lpSurface);

		/*// AlphaTable
		for(int i=0; i<5; i++)
		for(int j=0; j<5; j++)
		{
			sprintf(s,"[%d, %d]=%d" , i,j, (BYTE)AlphaTable[i,j]);
			SurfaceFnt.Draw_Text(s,5,dy+=SurfaceFnt.FontH,RGB(0,0,255),lpSurface);
		}*/

		//-----------------------------------
	}
  }
  else
  {
	  if (ShowDebugInfo)
	  {
	    int cx, cy, size=2;

	    for(int i=0; i<256; i++)
		{
			cx=(i+4)*size; cy=size;
		    DrawSurfaceEllipse(lpSecBuffer,cx,cy,size,
				RGB(ParticlePalette[i].peRed,ParticlePalette[i].peGreen,ParticlePalette[i].peBlue));
		}
	  }
  }
}


//---------------------------------------------------------------------------------
//epa------------------------------------------------------------------------
void DrawSmallMap(LPDIRECTDRAWSURFACE lpSurface)
{
  int i,
	  mx=SCREEN_WIDTH/2-GameWorld.WorldToMapX(GameWorld.ViewX), 
	  my=SCREEN_HEIGHT/2-GameWorld.WorldToMapY(GameWorld.ViewY);
  if(GameWorld.ShowMap) 
  {
	//eXa
	if (ShowAlphaBlend) GameWorld.BlendDrawMap2Surface(lpSurface,mx,my);
	else GameWorld.DrawMap2Surface(lpSurface, mx, my, true);

	//NҦ󪺦meb aϤW
	int x, y;
	for(i=0; i<TreeNum; i++)
	{
		x=mx+GameWorld.WorldToMapX(ObjTree[i].PosX());
		y=my+GameWorld.WorldToMapY(ObjTree[i].PosY());
		DrawSurfaceEllipse(lpSurface,x,y,1,RGB(0,0,255));
	}
		
	for(i=0; i<MonsterNum; i++)
	{
		x=mx+GameWorld.WorldToMapX(Monster[i].PosX());
		y=my+GameWorld.WorldToMapY(Monster[i].PosY());
		DrawSurfaceEllipse(lpSurface,x,y,1,RGB(0,255,0));
	}

	//Player
	x=mx+GameWorld.WorldToMapX(Player.PosX());
	y=my+GameWorld.WorldToMapY(Player.PosY());
	DrawSurfaceEllipse(lpSurface,x,y,1,RGB(255,0,0));
  }
}




//----------------------------------------------------------------------------------
void MoveViewSight()
{ 
	if (ArrowKeyDown[UP]&&ArrowKeyDown[DN]) Vy=0;
	else if (ArrowKeyDown[UP]) Vy=PanVec;
	else if (ArrowKeyDown[DN]) Vy=-PanVec;
	else Vy=0;

	if (ArrowKeyDown[RHT]&&ArrowKeyDown[LFT]) Vx=0;
	else if (ArrowKeyDown[RHT]) Vx=PanVec;
	else if (ArrowKeyDown[LFT]) Vx=-PanVec;
	else Vx=0;
	
	//GameWorld.IncMoveViewPoint(Vx,Vy);
	if (!Player.AutoMove) Player.IncMove(Vx,Vy);
}


//--------------------------------------------------------------------------------------
void AnimateObjects()
{
  MoveViewSight(); //Hɨ̾ PanVec ʵI

  if(!ShowParticle)
  {
	//Ӱʪ Object 
	for(int i=0; i<MonsterNum; i++)
	  Monster[i].Move();

	//pGO۰ʲʫhҰ Move(),  IncMove();
	if (Player.AutoMove) 
	{
	  if(AccelerateTp!=0) Player.Accelerate(AccelerateTp*dVec);
	  Player.Move();
	}
  }
  else
  {
	 //pGO۰ʲʫhҰ Move(),  IncMove();
	if (Player.AutoMove) 
	{
	  if(AccelerateTp!=0) Player.Accelerate(AccelerateTp*dVec);
	  Player.Move();
	}
     Fire.Wave();
  }

}


//-------------------------------------------------------------------------------
//Blur e----------------------------------------------------------------------
void BlurSurface(LPDIRECTDRAWSURFACE lpDestSurface)
{	
	DDSURFACEDESC dest_ddsd; //direct draw surface descriptor
	BYTE *dest; //destination and source pointers
		
	dest_ddsd.dwSize=sizeof(dest_ddsd);

	//ӷMت Surface OаϡAȮɤ\L{sC	
	if(FAILED(lpDestSurface->Lock(NULL,&dest_ddsd,DDLOCK_WAIT,NULL))) return;	
	
	dest=(BYTE*)dest_ddsd.lpSurface; //destination pointer
	int x,y , curPos, ddw=dest_ddsd.lPitch, rw=ddw-SCREEN_WIDTH;	

	curPos=ddw-rw;

	for(y=1; y< SCREEN_HEIGHT-1; y++)
	{
		curPos+=rw;

		for(x=1; x< SCREEN_WIDTH-1; x++)
		{
			curPos++;
			if(dest[curPos]!=0) 
			{	
				//WUkΥ|Өۥ[H8
				/*dest[curPos]=(dest[curPos-ddw-1]+dest[curPos-ddw]+dest[curPos-ddw+1]+
								dest[curPos-1]+dest[curPos+1]+
								dest[curPos+ddw-1]+dest[curPos+ddw]+dest[curPos+ddw+1])>>3;  //HK*/
				dest[curPos]=BlurTable[dest[curPos-ddw-1]+dest[curPos-ddw]+dest[curPos-ddw+1]+
								dest[curPos-1]+dest[curPos+1]+
								dest[curPos+ddw-1]+dest[curPos+ddw]+dest[curPos+ddw+1]];
			}
		}
	}

	//w
	lpDestSurface->Unlock(NULL);
}




//---------------------------------------------------------------------------------------
//ǳƦnU@iϡAe Secondary Surface------------------------------------------------
BOOL DrawNewFrame()
{  
  //ù WI------------	
  //DrawSurfaceRect(lpSurface, viewRect, RGB(0,0,0));
  ColorFillSurface(lpSecBuffer, 0);

  if(!ShowParticle)
  {
	//eI	
	if(!GameWorld.drawBackGround2Surface(lpSecBuffer))
	{ 
	    MessageBox (NULL, "Draw World Failed!","GameWorld.draw..()", MB_OK);
	    return FALSE;
	};   
  
	//b̪ḩǵeXUӪ,  ->  -> Y -> Ǫ ->......
	for(int i=0; i<TreeNum; i++) ObjTree[i].Draw(lpSecBuffer);

	for(i=0; i<MonsterNum; i++) Monster[i].Draw(lpSecBuffer);

	Player.Draw(lpSecBuffer);

	//̫eYpaϦb̤Wh-------------------------------------------------------
	DrawSmallMap(lpSecBuffer);	 
	
  }
  else
  {
	 //etΰOABzAe ܥdOAtפ֡C

	 //WlS---------------------------------------------------------------
	 Fire.Draw2Surface(lpSecBuffer);
	 //Blur-------------------------------------------------------------------
	 for(int i=0; i<2; i++) BlurSurface(lpSecBuffer);
  }  

	// Debug T
	DrawDebugInfo(lpSecBuffer);  

	//̫eܥdOC
	 lpSecSurface->BltFast(0,0,lpSecBuffer,NULL,DDBLTFAST_NOCOLORKEY|DDBLTFAST_WAIT);

  return TRUE;
} 



//HJ-----------------------------------------------------------------------------------
void FadeIn()
{
	PALETTEENTRY pePri[256];	//
	PALETTEENTRY peSec[256];	//

	lpPriPalette->GetEntries(0, 0, 256, pePri);
	lpSecPalette->GetEntries(0, 0, 256, peSec);	

	static float rate=0; 
	static float delta=1.0f/60; //60q

	rate += delta;	

	if (rate<1) 
	{
		for(int i = 0 ; i < 256; i++)
		{
			pePri[i].peRed	= (BYTE)(peSec[i].peRed  * rate);
			pePri[i].peGreen = (BYTE)(peSec[i].peGreen* rate);
			pePri[i].peBlue	= (BYTE)(peSec[i].peBlue * rate);
		}

		lpPriPalette->SetEntries(0, 0, 256, pePri);
	}
	else
	{
		FadeType=0;
		ResotrePalette();// Primary Palette break;		
		rate=0;
	}
}


void FadeOut()
{
	PALETTEENTRY pePri[256];	//
	PALETTEENTRY peSec[256];	//

	lpPriPalette->GetEntries(0, 0, 256, pePri);
	lpSecPalette->GetEntries(0, 0, 256, peSec);

	static float rate=1; 
	static float delta=1.0f/60; //60q

	rate -= delta;	

	if (rate>0) 
	{
		for(int i = 0 ; i < 256; i++)
		{
			pePri[i].peRed	= (BYTE)(peSec[i].peRed  * rate);
			pePri[i].peGreen = (BYTE)(peSec[i].peGreen* rate);
			pePri[i].peBlue	= (BYTE)(peSec[i].peBlue * rate);
		}

		lpPriPalette->SetEntries(0, 0, 256, pePri);
	}
	else
	{
		FadeType=0;
		ResotrePalette();// Primary Palette break;
		rate=1;
	}
}



//---------------------------------------------------------------------------------------
//Flip Primary<--->Secondary Surfaces-----------------------------------------------------
BOOL PageFlip()
{ 
#ifdef FULLSCREEN_DEBUG
  RECT Window;
  POINT pt;
  GetClientRect(hwnd, &Window);
  pt.x=pt.y=0;
  ClientToScreen(hwnd, &pt);
  OffsetRect(&Window, pt.x, pt.y);
  lpPriSurface->Blt(&Window, lpSecSurface, NULL, DDBLT_WAIT, NULL);
#else
  if(lpPriSurface->Flip(NULL,DDFLIP_WAIT)==DDERR_SURFACELOST) //DDERR_SURFACELOST: Surface OЪŶQ Free F
  { bool OK=RestoreSurfaces()&&ResotrePalette(); return OK;}
#endif

  return TRUE;
} 

//---------------------------------------------------------------------------------------
//ѸgLɶP_O_n Flip ʧ@F--------------------------------------------------
BOOL ProcessFrame()
{ 
  static int last_time=Timer.time();  

  AnimateObjects();

  DrawNewFrame(); //Hɤs lpSecBuffer e, ibU if C
  
  if(Timer.timeElapsed(last_time,FramePeriod)) 
  //jCiɶj(FramePeriod=1Sec/Frames)ɤ~U@i
  { 
	//HXHJ
	if(FadeType==1) FadeIn();
	else if(FadeType==2) FadeOut(); 

    return PageFlip(); 
  }  

  return true;
} 



//---------------------------------------------------------------------------------------
//BzLUpT------------------------------------------------------------------------
BOOL keyboardUp_handler(WPARAM keystroke)
{ 
  BOOL result=FALSE;    

  switch(keystroke)
  {  
	case VK_SHIFT:			
	case VK_CONTROL: AccelerateTp=0; break;
		
	case VK_UP:		ArrowKeyDown[UP]	=false;	break;
	case VK_LEFT:	ArrowKeyDown[LFT]	=false;	break;
	case VK_DOWN:	ArrowKeyDown[DN]	=false; break;
	case VK_RIGHT:  ArrowKeyDown[RHT]	=false; break;
	
    default: break;
  }
   
  return result;
} 


//---------------------------------------------------------------------------------------
//BzLJT------------------------------------------------------------------------
BOOL keyboardDown_handler(WPARAM keystroke)
{ 
  BOOL result=FALSE;  
  int vx, vy;

  switch(keystroke)
  {
	case 49:	CreateFirePalette(ParticlePalette); 
				lpPriPalette->SetEntries(0,0,256,ParticlePalette); break; // Key 1
	case 50:	CreateBluePalette(ParticlePalette);
				lpPriPalette->SetEntries(0,0,256,ParticlePalette);break; // Key 2

    case VK_SHIFT:
			if(Player.AutoMove) AccelerateTp=1;
			else {PanVec+=2; PanVec=(PanVec>400)?400:PanVec;}

			AlphaSpriteGirl.SetAlpha(PanVec); 

			break;
	case VK_CONTROL: 
			if(Player.AutoMove) AccelerateTp=-1;
			else {PanVec-=2; PanVec=(PanVec<2)?2:PanVec;}

			AlphaSpriteGirl.SetAlpha(PanVec); 

			break;

	case VK_UP:		ArrowKeyDown[UP]	=true;		break;
	case VK_DOWN:	ArrowKeyDown[DN]	=true;		break;
	case VK_LEFT:	ArrowKeyDown[LFT]	=true;		break;
	case VK_RIGHT:	ArrowKeyDown[RHT]	=true;		break;

	case VK_F1:		GameWorld.MapColor
						=ImgBackground.GetPaletteColor(Random.number(0,200));
					ShowDebugInfo=!ShowDebugInfo;	break;
	case VK_F2:		GameWorld.ShowMap=!GameWorld.ShowMap;	break;
	case VK_F3:		ShowSurfaces=!ShowSurfaces;				break;
	case VK_F4:		ShowAlphaBlend=!ShowAlphaBlend;			break;			

	case VK_F5:		GameWorld.RandomCreate(&ImgBackground, SCREEN_WIDTH*10,SCREEN_WIDTH*10);
					CreateObjects(); debugID=0;
					break;

	case VK_F6:		Player.AutoMove=!Player.AutoMove; break;
	case VK_F7:		FadeType=1; break;
	case VK_F8:		FadeType=2; break;
	case VK_F9:		ShowParticle=!ShowParticle; ResotrePalette(); break;
	case VK_SPACE: 	GameWorld.GetRandomPosInWorld(&vx, &vy); DrawID=(DrawID+1)%2;
					//GameWorld.SetViewPoint(vx, vy); 
					Player.SetPos(vx, vy); break;
    case VK_ESCAPE: result=TRUE; break; //exit game
    default: break;
  }   

  return result;
} 


//Ҧ Surfaces Ŷ----------------------------------------------------------
void ReleaseAllSurfaces()
{
	if(lpDdObject)
	{ 
		if(lpSecSurface) lpSecSurface->Release(); //release secondary surface
		if(lpPriSurface) lpPriSurface->Release(); //release primary surface		
		if(lpMsgSurface) lpMsgSurface->Release();	
		if(lpSecBuffer)  lpSecBuffer->Release();

		GameWorld.ReleaseSurfaces();	
		SpriteGirl.ReleaseSurfaces();
		AlphaSpriteGirl.ReleaseSurfaces();

		for(int i=center; i<=corner315; i++)
		SpriteMonster[i].ReleaseSurfaces();
	    
        lpDdObject->Release(); //release DD object
	}  
}


void MakeRect(RECT *rect, short left, short top, short width, short height)
{
	rect->left=left;
	rect->top=top;
	rect->right=left+width;
	rect->bottom=top+height;
}

//վjp--------------------------------------------------------------
void AdjustWindowSize(HWND hwnd)
{
	RECT rect;
	MakeRect(&rect, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
	AdjustWindowRectEx( &rect,
						GetWindowStyle(hwnd),
						GetMenu(hwnd)!=NULL,
						GetWindowExStyle(hwnd));

	//ùW
	MoveWindow( hwnd,0,0,SCREEN_WIDTH,SCREEN_HEIGHT,TRUE);

	/*//ù
	MoveWindow( hwnd,
		(GetSystemMetrics(SM_CXFULLSCREEN)-(rect.right-rect.left))/2,
		(GetSystemMetrics(SM_CYFULLSCREEN)-(rect.bottom-rect.top))/2,
		rect.right-rect.left,
		rect.bottom-rect.top,
		TRUE);*/
}





//**************************************************************************************
//{ĤGJfABz Windows Messages--------------------------------------------------
long CALLBACK WindowProc(HWND hwnd,UINT message, WPARAM wParam,LPARAM lParam)
{
 
  switch(message)
  {
    case WM_ACTIVATEAPP: ActiveApp=wParam; break;
    case WM_CREATE: break;
	case WM_SIZE:
		//SCREEN_WIDTH = LOWORD(lParam);  // width of client area 
		//SCREEN_HEIGHT = HIWORD(lParam); // height of client area
	    AdjustWindowSize(hwnd);
		break;
	case WM_KEYUP:
      keyboardUp_handler(wParam); 
	  break;
    case WM_KEYDOWN: //UL
      if(keyboardDown_handler(wParam))
	  {
		  //MessageBox (NULL, "Exit Game!","GameWorld Msg Box", MB_OK);
		  DestroyWindow(hwnd);  //禡Atη|^e WM_DESTROY message {
	  }
      break;
    case WM_DESTROY: // Window Destroy T     

      ReleaseAllSurfaces();      

      ShowCursor(TRUE); //show the mouse cursor
      PostQuitMessage(0); // iDtΤwg WM_DESTROY, 㤩C
      break;
    default: //default window procedure
      return DefWindowProc(hwnd,message,wParam,lParam);
  } //switch(message)
  return 0L;
} 




//**************************************************************************************
//{DJf----------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
  MSG msg;	//current message  
  //HWND hwnd; //handle to fullscreen window

  InitialVariable();  

  //إ Window
  hwnd=CreateDefaultWindow("GameWorld Demo",hInstance);
  if(!hwnd)return FALSE;

  //]w Window
  ShowWindow(hwnd,nCmdShow); 
  UpdateWindow(hwnd);
  SetFocus(hwnd); //allow input from keyboard

#ifdef FULLSCREEN_DEBUG
  ShowCursor(TRUE); //hide the cursor
#else
  ShowCursor(FALSE); //hide the cursor
#endif

  //AdjustWindowSize(hwnd);

  
  //------------------------------------------------------------------------   
  //إ DirectDraw  ( ھSCREEN_WIDTH, SCREEN_HEIGHT, COLOR_DEPTH ) C
  BOOL OK=CreateDirectDraw(hwnd, &lpDdObject, SCREEN_WIDTH, SCREEN_HEIGHT, 
							 GameCOLOR_DEPTH);
  if(!OK)
  { 
    MessageBox (NULL, "Game initial Failed!","CreateDirectDraw()", MB_OK);
    DestroyWindow(hwnd); return FALSE;
  }  

  // primary M Secondary Surface tmŶC
  if(OK) OK=CreateFlipSurfaces(hwnd, lpDdObject, &lpPriSurface, &lpPriPalette,
							   &lpSecSurface, &lpSecPalette);
  if(!OK)
  { 
    MessageBox (NULL, "Game initial Failed!","CreateFlipSurfaces()", MB_OK);
    DestroyWindow(hwnd); return FALSE;
  }  
  //-------------------------------------------------------------------------

  
  //}lŪJϧθ---------------------------------------------------------
  if(OK) OK=LoadImages(); //load images from disk
  if(!OK)
  { 
    MessageBox (NULL, "Game initial Failed!","LoadImages()", MB_OK);
    DestroyWindow(hwnd); return FALSE;
  }

  //إߤltΪL--------------------------------------------------------
  CreateFirePalette(ParticlePalette);
  //CreateBluePalette(ParticlePalette);

  //ƥp BlurTable
  for (int i=0; i<256*8; i++) BlurTable[i]=i>>3;

  //إSin Cos table---------------------------------------------------------
  Init_CosSinTable();
  

  //ھڹɤjpL OffScreen Surfaces tmŶ--------------------------
  if(OK) OK=CreateSystemSurfaces(false, hwnd,lpDdObject, &lpMsgSurface,
					ImgMsgWnd.ImageWidth(), ImgMsgWnd.ImageHeight())&&
			CreateSystemSurfaces(true, hwnd,lpDdObject, &lpSecBuffer,
					SCREEN_WIDTH, SCREEN_HEIGHT);

	 

  /*// For Debug Usage----------------------------------------------------
  if(!OK)
  { 
	char s[5];
	sprintf(s,"%d",debugID);
    MessageBox (NULL, "Game initial Failed!",s, MB_OK);
    DestroyWindow(hwnd); return FALSE;
  }*/

  
  //NImageƽƻsҦ OffScreen  Surfaces W-------------------------------
  //( ϧθ->OffScreen Surface; L->Flip Surface )C		
  if(OK) OK=DrawImageToSurfaces();  
  if(!OK)
  { 
    MessageBox (NULL, "Game initial Failed!","DrawImageToSurfaces()", MB_OK);
    DestroyWindow(hwnd); return FALSE;
  }  


  //ھ lpSecPalette إ Alpha Table-----------------------------------------
  if(OK) OK=CreateAlphaTable(lpSecPalette);
  
  
  //pGHWBJѡAheX WM_Destroy Tۨ WindowAϥ DestroyWindow();
  if(!OK)
  { 
    MessageBox (NULL, "Game initial Failed!","GameWorld Msg Box", MB_OK);
    DestroyWindow(hwnd); return FALSE;
  }  


  //}lpɾ
  Timer.start();

  //إߩҦ Object----------------------------------------------------------
  if(OK) OK=CreateObjects();  
  if(!OK)
  { 
    MessageBox (NULL, "Game initial Failed!","CreateObjects()", MB_OK);
    DestroyWindow(hwnd); return FALSE;
  }  
	


  //{D^ message loop
  while(TRUE)
  if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
  {
      if(!GetMessage(&msg,NULL,0,0)) return msg.wParam;
      TranslateMessage(&msg); DispatchMessage(&msg);
  }
  else if (ActiveApp) { ProcessFrame(); }
  else WaitMessage();
} 



//ܰT-------------------------------------------------------------------------
void ShowMsgWindow(LPDIRECTDRAWSURFACE lpSurface, int x, int y, char *str, unsigned char alpha)
{
	int BlendW=ImgMsgWnd.ImageWidth(), BlendH=ImgMsgWnd.ImageHeight();
	int destx,desty,destw, desth, srcx,srcy,srcw,srch;
	destx=x;//(SCREEN_WIDTH-BlendW)/2;
	desty=y;//(SCREEN_HEIGHT-BlendH)/2;
	destw=BlendW;
	desth=BlendH;
	srcx=0;  srcy=0;  srcw=BlendW;  srch=BlendH;	
	BlendSurface(lpSurface, destx, desty, destw, desth, lpMsgSurface, 
				srcx, srcy, srcw, srch, alpha);	
	
	HDC hdc;
	lpSurface->GetDC(&hdc);
	SIZE size;
	GetTextExtentPoint(hdc, str, lstrlen(str), &size);
	SetBkMode(hdc,TRANSPARENT);
	TextOut(hdc, (BlendW - size.cx) / 2+x, (BlendH- size.cy) / 2+y, 
			str, strlen(str));
	//TextOut(hdc, 0, 0, szFrontMsg, lstrlen(szFrontMsg));
	lpSurface->ReleaseDC(hdc);	
}

//End**************************************************************************************
