//WorldSystem.cpp: member functions for the WorldSystem.h 
//Daniel CopyRight Reserved December, 5, 2001


//System includes
#include <stdio.h>
#include <math.h>


//Custom includes
#include "WorldSystem.h"//header file
#include "random.h"
#include "DanielMath.h"
#include "Font.h"
#include "ddrawUtil.h"


extern CRandom Random;
extern LPDIRECTDRAW lpDdObject;
extern CDdFont SurfaceFnt;

//Debug Variable
extern int hitX, hitY, debugID;
extern LPDIRECTDRAWSURFACE lpPriSurface;


// Varialble
int bkgX[corner315+1],bkgY[corner315+1],bkgW[corner315+1],bkgH[corner315+1];
int MapW=SCREEN_WIDTH/3,MapH=MapW;



//constructors------------------------------------------------------------------------ 
CWorld2D::CWorld2D() //constructor
{ 
  WorldRow=NULL; //NWordLineƩҦbЪl NULL
  for (int i=center; i<=corner315+1; i++) lpBkgSurface[i]=NULL;  
  lpMapSurface=NULL;
  
  MapPt=0; //MapColor=RGB(158,200,114);
  MapSidePixel=3;

  ColNum=0;  RowNum=0;  ShowMap=true;

  //]wI
  ViewX=ViewY=0;
}

//destructors --------------------------------------------------------------------
CWorld2D::~CWorld2D()
{ 
  if (WorldRow) delete[] WorldRow; //reclaim memory from image data
  for (int i=center; i<=corner315+1; i++) lpBkgSurface[i]=NULL;
  lpMapSurface=0;

  if (MapPt) delete[] MapPt;
}


//ھ ImgBkgPtr ϧθƦ۰ʭp bkgX[], bkgY[].......--------------------------
void CWorld2D::AutoCaculateSize()
{
	int BkgUnitW, BkgUnitH, SideSpace=150, //Tw150 Pixels
	x[3]={0,0,0}, y[3]={0,0,0};


	BkgUnitW = ImgBkgPtr->ImageWidth() - 2*SideSpace - 4;
	BkgUnitH = ImgBkgPtr->ImageHeight()- 2*SideSpace - 4;

	x[0]=1; x[1]=SideSpace+2; x[2]=SideSpace+BkgUnitW+3;
	y[0]=1; y[1]=SideSpace+2; y[2]=SideSpace+BkgUnitH+3;
    
	bkgX[center]=x[1]; 
	bkgY[center]=y[1]; 
	bkgW[center]=BkgUnitW; 
	bkgH[center]=BkgUnitH;
	
	bkgX[left]=x[0];
	bkgY[left]=y[1];
	bkgW[left]=SideSpace;
	bkgH[left]=BkgUnitH;

	bkgX[right]=x[2];
	bkgY[right]=y[1];
	bkgW[right]=SideSpace;
	bkgH[right]=BkgUnitH;

	bkgX[top]=x[1];		
	bkgY[top]=y[0];
	bkgW[top]=BkgUnitW;
	bkgH[top]=SideSpace;		
	
	bkgX[bottom]=x[1];	
	bkgY[bottom]=y[2];
	bkgW[bottom]=BkgUnitW;
	bkgH[bottom]=SideSpace;

	bkgX[corner45]=x[2];	
	bkgY[corner45]=y[0];
	bkgW[corner45]=SideSpace;
	bkgH[corner45]=SideSpace;

	bkgX[corner135]=x[0];	
	bkgY[corner135]=y[0];
	bkgW[corner135]=SideSpace;
	bkgH[corner135]=SideSpace;

	bkgX[corner225]=x[0];	
	bkgY[corner225]=y[2];
	bkgW[corner225]=SideSpace;
	bkgH[corner225]=SideSpace;

	bkgX[corner315]=x[2];	
	bkgY[corner315]=y[2];
	bkgW[corner315]=SideSpace;
	bkgH[corner315]=SideSpace;
}


BOOL CWorld2D::CreateSurfaces()
{
	//إDirectDraw  OffScreen Surface: I background surface--------------------------
	
	DDSURFACEDESC ddsd; //direct draw surface descriptor 

	//]wz⪺ L index  
	DDCOLORKEY ddck; //direct draw color descriptor
	for (int i=center; i<=corner315; i++)
	{    
		//إ  surface
		ddsd.dwSize=sizeof(ddsd);
		ddsd.dwFlags=DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH;
		//]wª Surface  Flip  Alpha Blend 
		ddsd.ddsCaps.dwCaps= DDSCAPS_SYSTEMMEMORY|DDSCAPS_OFFSCREENPLAIN;
		//]wSurfacee
		ddsd.dwHeight=bkgH[i];//SCREEN_HEIGHT; 
		ddsd.dwWidth=bkgW[i];//SCREEN_WIDTH;	
		
		ddck.dwColorSpaceLowValue= ddck.dwColorSpaceHighValue=TRANSPARENT_COLOR; //one color

		//tm Background Surface Ŷ
		if(FAILED(lpDdObject->CreateSurface(&ddsd,&lpBkgSurface[i],NULL)))
		return FALSE;	

		//]wz
		lpBkgSurface[i]->SetColorKey(DDCKEY_SRCBLT,&ddck);
	}


	//إWorld OverviewaϪ Surface--------------------------------------------------
	ddsd.dwSize=sizeof(ddsd);
	ddsd.dwFlags=DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH;
	//]wª Surface  Flip  Alpha Blend 
	ddsd.ddsCaps.dwCaps=DDSCAPS_SYSTEMMEMORY|DDSCAPS_OFFSCREENPLAIN;
	  
	//]wSurfacee
	ddsd.dwHeight=MapH; 
	ddsd.dwWidth=MapW;
	
	//tm Background Surface Ŷ
	if(FAILED(lpDdObject->CreateSurface(&ddsd,&lpMapSurface,NULL)))
	return FALSE;

	return TRUE;
}


void CWorld2D::ReleaseSurfaces()
{
	int i;

	if(lpMapSurface) lpMapSurface->Release();

	if(lpBkgSurface)
	{
	  for (i=center; i<=corner315; i++)
	  if(lpBkgSurface[i]) lpBkgSurface[i]->Release();	  
	}

	for (i=center; i<=corner315+1; i++) lpBkgSurface[i]=NULL;
    lpMapSurface=NULL;
}


//eҦϧθƨ Surfaces W-------------------------------------------------------
BOOL CWorld2D::RestoreSurfaces()
{
	bool result=true;

	if(SUCCEEDED(lpMapSurface->Restore()))
       result=result&&DrawWorldMap2MapSurface(); //redraw image
    else return FALSE;

	//eI Surface 
	for (int i=center; i<=corner315; i++)
	if(SUCCEEDED(lpBkgSurface[i]->Restore()))
		result=result&&ImgBkgPtr->draw2Surface(lpBkgSurface[i], bkgW[i], bkgH[i], bkgX[i], bkgY[i]);
	else return FALSE;

	return result;
}


//Random Create a World-----------------------------------------------------------
BOOL CWorld2D::RandomCreate(CBmpSpriteFileReader *ImgBkgndPtr, int worldW, int worldH) //constructor
{ 
  if (!ImgBkgndPtr) return FALSE;
  

  if (WorldRow) delete[] WorldRow; //reclaim memory from image data  
  WorldRow=NULL; //NWordLineƩҦbЪl NULL
  if (MapPt) delete[] MapPt;
  MapPt=NULL;
  //------------------------------------------------------------------

  ImgBkgPtr=ImgBkgndPtr;

  //ӶǡG1. X SurfacesjpC 2.즳 Surfaces ŶC 3.stm Surfaces ŶC
  //4. NϧθƵe Surfaces W
  
  //1.p lpBkgSurface[] U surfaces b ImgBkgPtr-> ϧθƤWmBjp 
  AutoCaculateSize();
  //2.O--------------------------------------------
  ReleaseSurfaces();  
  //3.ھڱo쪺jptm Surface Ŷ
  CreateSurfaces();
  //4.۱N ImgBkgPtr->ϧθƵe Surfaces 
  RestoreSurfaces();
  //---------------------------------------------------------------
 

  //MapColor=ImgBkgPtr->GetPaletteColor(5);
  MapColor=RGB(0,255,255);
  
  //]w Private  Iɪe
  //ݬO_WLw]̤je MaxWorldPixelW (wqb Glvar.h)AΤpw]̤pe
  worldW=(worldW>MaxWorldPixelW)?MaxWorldPixelW:worldW;    
  worldW=(worldW<MinWorldPixelW)?MinWorldPixelW:worldW;
  ColNum=worldW/bkgW[center];
  ColNum=(ColNum>3)?ColNum:4;

  //ݬO_WLw]̤j MaxWorldPixelH (wqb Glvar.h)AΤpw]̤p
  worldH=(worldH>MaxWorldPixelH)?MaxWorldPixelH:worldH;    
  worldH=(worldH<MinWorldPixelH)?MinWorldPixelH:worldH;
  RowNum=worldH/bkgH[center];
  RowNum=(RowNum>3)?RowNum:4;

  //}ltmWorld ƪŶ
  WorldRow=new RowRec[RowNum];  //` Line Ƶ Row (TbkgH) [W 1  
  
   
  //ŧi@ܼ RowBaseAѦk X startCol M endCol
  short RowBaseCol;
  RowBaseCol=Random.number(1,ColNum-2);

  for (int i=0; i<RowNum; i++)
  {	 
    //b0  W@ RowBaseCol-1 s_I startCol
	WorldRow[i].startCol=Random.number(0, RowBaseCol-1); 
	
	//bs RowBaseCol+1 M ColNum-1 sI endCol
    WorldRow[i].endCol=Random.number(RowBaseCol+1,ColNum-1); 
	
	//Aq Row  Col @ӧ@sU@ Row  Row Base
	RowBaseCol=Random.number(WorldRow[i].startCol+1, WorldRow[i].endCol-1);
  }
 

  //eYpa---------------------------------------------------------
  int PtNum=4*RowNum, icurPt=0;  //CC|ӺI
  double ColPixels, RowPixels; 

  //p Ypa CCCh Pixels
  if (worldW>worldH)
	  MapResolution=double(MapW-MapSidePixel*2)/worldW; //-2OFWUΥkUdU@ Pixel e
  else
	  MapResolution=double(MapH-MapSidePixel*2)/worldH;

  ColPixels=MapResolution*bkgW[center]; 
  RowPixels=MapResolution*bkgH[center];     

  MapPt=new POINT[PtNum+1]; //+1: [W̫@I ==> MapPt[0];

  // DҦ Row I
  for(i=0; i<RowNum; i++)
  {
    MapPt[icurPt].x=int(ColPixels*WorldRow[i].startCol)+MapSidePixel;
	MapPt[icurPt].y=int(MapH-i*RowPixels-MapSidePixel);
	icurPt++;

	MapPt[icurPt].x=MapPt[icurPt-1].x;	
	MapPt[icurPt].y=MapPt[icurPt-1].y-int(RowPixels);
	icurPt++;
  }
  // ADҦ Row kI
  for(i=RowNum-1; i>=0; i--)
  {
    MapPt[icurPt].x=int(ColPixels*(WorldRow[i].endCol+1))+MapSidePixel;
	MapPt[icurPt].y=int(MapH-(i+1)*RowPixels-MapSidePixel);
	icurPt++;

	MapPt[icurPt].x=MapPt[icurPt-1].x;	
	MapPt[icurPt].y=MapPt[icurPt-1].y+int(RowPixels);
	icurPt++;
  }

  MapPt[icurPt]=MapPt[0];

  DrawWorldMap2MapSurface();

  //Hlm--------------------------------------------------
  GetRandomPosInWorld(&ViewX, &ViewY);   

  return TRUE;
}

//]wIy, ö}le---------------------------------------------------------
void CWorld2D::SetViewPoint(int x, int y)
{
  if (!lpBkgSurface) return;

  short iRow, iCol;
  if (!InsideWorld(x, y, &iRow, &iCol)) return;

  ViewX=x; ViewY=y;
}

//NIqثe (ViewX, ViewY) ʨs (x,y)-----------------------------------
void CWorld2D::MoveViewPoint(int *x, int *y)
{
  short iRow, iCol;
  int xc, yc, signSideX, signSideY;

  //for (int i=0; i<100000; i++) HitWorldEdge(ViewX,ViewY,&x,&y,&xc,&yc); //100000ĪG٤

  if (HitWorldEdge(ViewX,ViewY,x,y,&xc,&yc))
  { 
	//pGϼuIbİϰ쪺
	if(InsideWorld(*x, *y, &iRow, &iCol))
	{ 
	   signSideX=(xc-*x)*(xc-ViewX);
	   signSideY=(yc-*y)*(yc-ViewY);


	   if (signSideY==0) //﫫Ϯg, X GC
	   {
		   ViewX=(ViewX+xc)/2;	//x G		   
		   //ViewY=y;
	   }
	   else if (signSideX==0) //䫫ϮgAY GC
	   {
		   ViewY=(ViewY+yc)/2;
		   //ViewX=x;
	   }
	   else //D]DϮg
	   {
		  if (signSideX<0) //䦳פϮg
		  {
			ViewY=*y;//(ViewY+yc)/2;	//y G
			ViewX=*x;				//x Ϯgm
		  }
		  else //﫫䦳פϮg
		  {
		    ViewX=*x;
		    ViewY=*y;
		  }
	   }	   
	} 
	else
	{ViewX=xc; ViewY=yc;}	//I (I)
  }
  else
  {
    ViewX=*x; ViewY=*y;    
  }  

  /*
  int oldx=x, oldy=y;
  //DIϮgI world sII@sϮgI  
  if (HitWorldEdge(xc, yc, &oldx, &oldy, &x, &y)) return;	
  ViewX=x; ViewY=y; //sϮgI
  */
  hitX=xc; hitY=yc;
}
  

//Wq-------------------------------------------------------------------------
void CWorld2D::IncMoveViewPoint(int dx, int dy)
{
	int x=ViewX+dx, y=ViewY+dy;
	MoveViewPoint(&x, &y);
}


//P_O_b World --------------------------------------------------------------
bool CWorld2D::InsideWorld(int x, int y, short *posRow, short *posCol)
{ 
  if (!lpBkgSurface) return false;

  (*posRow)=(*posCol)=-1;

  if (!WorldRow) return false;

  *posRow=RowOfXY(y);	//  (x, y) Ҧb Row No.
  *posCol=ColOfXY(x);	//  (x, y) Ҧb Col No.    

  //pGb̤j World Rectangle ~ܸX
  if ((*posRow<0)||(*posRow>=RowNum)||(*posCol<0)||(*posCol>=ColNum)) return false;

  //pGҦb Col No. bӦC(posRow) Ľd (Ob WordRowLine ) ܡAǦ^ falseC
  if ((*posCol<WorldRow[*posRow].startCol) || (*posCol>WorldRow[*posRow].endCol))
	return false;

  return true;
}


//P_O_töǦ^IΦĤϮgI--------------------------------------------------
bool CWorld2D::HitWorldEdge(int x1, int y1, int *x2, int *y2, int *xc, int *yc)
{ //(x2, y2)OsتIA(xc, yc)OI(I)C
  
  float m1,m2;  //m1O ptStart-ptEndײv, m2 O Edge ײv 
  short curRow, curCol, nxtRow, nxtCol, Lx, Rx;	
  int i, x3, y3, x4, y4, sidePixels=3, 
	  SpringD=5; //SpringD VpAViHe{uꪺϮgסAOӤpܷ||PIC
  bool blHitted=FALSE;
 
  *xc=*x2; *yc=*y2; 

  curRow=RowOfXY(y1); 
  if(curRow>=RowNum) curRow=RowNum-1;
  else if(curRow<0) curRow=0;
  curCol=ColOfXY(x1);

  nxtRow=RowOfXY(*y2); 
  if(nxtRow>=RowNum) nxtRow=RowNum-1;
  else if(nxtRow<0) nxtRow=0;
  nxtCol=ColOfXY(*x2); 


  /*//for debug use-----------------------------------------------
  if(!InsideWorld(*x2, *y2, &nxtRow, &nxtCol))
  {
	char s[30];
	sprintf(s,"curRow:%-3d, nxtRow:%-3d" ,curRow, nxtRow);
	SurfaceFnt.Draw_Text(s,5,120,RGB(255,0,0),lpPriSurface);
  }
 //------------------------------------------------------------*/

  debugID=0;
  
  if (nxtRow==curRow) //P@C
  {	 debugID=7; 
	 x3=(WorldRow[curRow].startCol)*bkgW[center]+1;//+sidePixels; 
     x4=(WorldRow[curRow].endCol+1)*bkgW[center]-1;//-sidePixels;	//֥I֧PAx Y sidePixels=2;
	 y3=curRow*bkgH[center]+1;//+sidePixels; 
	 y4=y3+bkgH[center]-2;//-sidePixels; //֥I֧PAy WUU sidePixelC
	 
	 if (!blHitted)
     if (*x2>x1)//k䲾
	 {	
		if(*y2>y1)  //kWʡAiMkɡBWɬۥ
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x4, y3, x4, y4, &m1, &m2, xc, yc)) //kɬۥ
			{
				if(*x2==*xc) *x2=*xc-SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true;	debugID=11;							
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y4, x4, y4, &m1, &m2, xc, yc)) //Wɬۥ
			{
				if(curRow>=RowNum-1)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[RowNum-1].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[RowNum-1].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[curRow+1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[curRow+1].endCol+1)*bkgW[center]-sidePixels;
				}

				if((*xc<=Lx) || (*xc>=Rx))
				{
					if(*y2==*yc) *y2=*yc-SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true;	debugID=12;								
				}
			}		
		}
		else if(*y2<y1) //kU
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x4, y3, x4, y4, &m1, &m2, xc, yc)) //kɬۥ
			{
				if(*x2==*xc) *x2=*xc-SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true;	debugID=13;								
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x4, y3, &m1, &m2, xc, yc)) //Uɬۥ
			{
				if(curRow<=0)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[0].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[0].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[curRow-1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[curRow-1].endCol+1)*bkgW[center]-sidePixels;
				}

				if(*xc<=Lx || *xc>=Rx)
				{
					if(*y2==*yc) *y2=*yc+SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true;	debugID=14;								
				}
			}
		}
		else //if(*y2==y1) //k䲾
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x4, y3, x4, y4, &m1, &m2, xc, yc)) //kɬۥ
			{
				if(*x2==*xc) *x2=*xc-SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true;	debugID=15;								
			}			
		}	   	
	 }
	 else if (*x2<x1) //
	 {		 
		if(*y2>y1)  //W
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x3, y4, &m1, &m2, xc, yc)) //ɬۥ
			{
				if(*x2==*xc) *x2=*xc+SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true; debugID=16;									
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y4, x4, y4, &m1, &m2, xc, yc)) //Wɬۥ
			{
				if(curRow>=RowNum-1)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[RowNum-1].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[RowNum-1].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[curRow+1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[curRow+1].endCol+1)*bkgW[center]-sidePixels;
				}

				if((*xc<=Lx) || (*xc>=Rx))
				{
					if(*y2==*yc) *y2=*yc-SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true;	debugID=17;								
				}					
			}					
		}
		else if(*y2<y1) //U
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x3, y4, &m1, &m2, xc, yc)) //ɬۥ
			{
				if(*x2==*xc) *x2=*xc+SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true;	debugID=18;								
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x4, y3, &m1, &m2, xc, yc)) //Uɬۥ
			{
				if(curRow<=0)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[0].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[0].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[curRow-1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[curRow-1].endCol+1)*bkgW[center]-sidePixels;
				}

				if(*xc<=Lx || *xc>=Rx)
				{
					if(*y2==*yc) *y2=*yc+SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true;	debugID=19;								
				}					
			}
		}
		else //if(*y2==y1) //䲾
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x3, y4, &m1, &m2, xc, yc)) //ɬۥ
			{
				if(*x2==*xc) *x2=*xc+SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true;	debugID=20;								
			}
		}
	 }
	 else //if (*x2==x1)
	 {
		if(*y2>y1)  //W貾
		{
			if (LineCrossInPt(x1, y1, *x2, *y2, x3, y4, x4, y4, &m1, &m2, xc, yc)) //Wɬۥ
			{
				if(curRow>=RowNum-1)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[RowNum-1].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[RowNum-1].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[curRow+1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[curRow+1].endCol+1)*bkgW[center]-sidePixels;
				}

				if((*xc<=Lx) || (*xc>=Rx))
				{
					if(*y2==*yc) *y2=*yc-SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true; debugID=21;									
				}							
			}			
		}
		else if(*y2<y1) //U貾
		{	
			if (LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x4, y3, &m1, &m2, xc, yc)) //Uɬۥ
			{
				if(curRow<=0)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[0].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[0].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[curRow-1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[curRow-1].endCol+1)*bkgW[center]-sidePixels;
				}

				if(*xc<=Lx || *xc>=Rx)
				{
					if(*y2==*yc) *y2=*yc+SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true;	debugID=22;								
				}						
			}
		}
		else //if(*y2==y1) //
		{
			if(*x2==x3) {*xc=x3; *x2=x3+SpringD; blHitted=true; debugID=23;}
			else if(*x2==x4) {*xc=x4; *x2=x4-SpringD; blHitted=true; debugID=24;}

			if(*y2==y3) {*yc=y3; *y2=y3+SpringD; blHitted=true; debugID=25;}
			else if(*y2==y4) {*yc=y4; *y2=y4-SpringD; blHitted=true; debugID=26;}
		}
	 }
  }
  else if (nxtRow>curRow) // bWC uiMBkBWɬۥ
  for (i=curRow; i<=nxtRow; i++)
  {  debugID=8;
	 x3=(WorldRow[i].startCol)*bkgW[center]+1;//+sidePixels;
	 x4=(WorldRow[i].endCol+1)*bkgW[center]-1;//-sidePixels;
	 y3=i*bkgH[center]+1;//+sidePixels; 
	 y4=y3+bkgH[center]-2;//-sidePixels;

	 if (!blHitted)
     if (*x2>x1)//k䲾
	 {	
		if(*y2>y1)  //kWʡAiMkɡBWɬۥ
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x4, y3, x4, y4, &m1, &m2, xc, yc)) //kɬۥ
			{
				if(*x2==*xc) *x2=*xc-SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true; debugID=27; break; 								
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y4, x4, y4, &m1, &m2, xc, yc)) //Wɬۥ
			{
				if(i>=RowNum-1)
				{
					Rx=WorldRow[RowNum-1].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[RowNum-1].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[i+1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[i+1].endCol+1)*bkgW[center]-sidePixels;
				}

				if((*xc<=Lx) || (*xc>=Rx))
				{
					if(*y2==*yc) *y2=*yc-SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true;	debugID=28; break;							
				}
			}		
		}
		
	 }
	 else if (*x2<x1) //
	 {		 
		if(*y2>y1)  //W
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x3, y4, &m1, &m2, xc, yc)) //ɬۥ
			{
				if(*x2==*xc) *x2=*xc+SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true;	debugID=29; break;							
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y4, x4, y4, &m1, &m2, xc, yc)) //Wɬۥ
			{
				if(i>=RowNum-1)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[RowNum-1].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[RowNum-1].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[i+1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[i+1].endCol+1)*bkgW[center]-sidePixels;
				}				

				if((*xc<=Lx) || (*xc>=Rx))
				{
					if(*y2==*yc) *y2=*yc-SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true; debugID=30; break;								
				}					
			}					
		}		
	 }
	 else //if (*x2==x1)
	 {
		if(*y2>y1)  //W貾
		{
			if (LineCrossInPt(x1, y1, *x2, *y2, x3, y4, x4, y4, &m1, &m2, xc, yc)) //Wɬۥ
			{
				if(i>=RowNum-1)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[RowNum-1].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[RowNum-1].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[i+1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[i+1].endCol+1)*bkgW[center]-sidePixels;
				}				

				if((*xc<=Lx) || (*xc>=Rx))
				{
					if(*y2==*yc) *y2=*yc-SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true;	debugID=31; break;							
				}							
			}			
		}		
	 }
  }	
  else  //if (nxtRow<curRow) //UC
  for (i=curRow; i>=nxtRow; i--)
  {  debugID=9;

	 x3=(WorldRow[i].startCol)*bkgW[center]+1;//+sidePixels;
	 x4=(WorldRow[i].endCol+1)*bkgW[center]-1;//-sidePixels;
     y3=i*bkgH[center]+1;//+sidePixels; 
	 y4=y3+bkgH[center]-2;//-sidePixels;
	 
	 if (!blHitted)
     if (*x2>x1)//k䲾
	 {	
		if(*y2<y1) //kU
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x4, y3, x4, y4, &m1, &m2, xc, yc)) //kɬۥ
			{
				if(*x2==*xc) *x2=*xc-SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true;	debugID=32; break;							
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x4, y3, &m1, &m2, xc, yc)) //Uɬۥ
			{
				if(i<=0)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[0].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[0].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[i-1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[i-1].endCol+1)*bkgW[center]-sidePixels;
				}

				if(*xc<=Lx || *xc>=Rx)
				{
					if(*y2==*yc) *y2=*yc+SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true; debugID=33; 	break;							
				}
			}
		}		   	
	 }
	 else if (*x2<x1) //
	 {		 
		if(*y2<y1) //U
		{
			if(LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x3, y4, &m1, &m2, xc, yc)) //ɬۥ
			{
				if(*x2==*xc) *x2=*xc+SpringD;
				else *x2=2*(*xc)-*x2; //*y2=*y2;
				blHitted=true; debugID=34; 	break;							
			}
			else if (LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x4, y3, &m1, &m2, xc, yc)) //Uɬۥ
			{
				if(i<=0)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[0].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[0].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[i-1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[i-1].endCol+1)*bkgW[center]-sidePixels;
				}

				if(*xc<=Lx || *xc>=Rx)
				{
					if(*y2==*yc) *y2=*yc+SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true; debugID=35; 	break;							
				}					
			}
		}		
	 }
	 else //if (*x2==x1)
	 {
		if(*y2<y1) //U貾
		{	
			if (LineCrossInPt(x1, y1, *x2, *y2, x3, y3, x4, y3, &m1, &m2, xc, yc)) //Uɬۥ
			{
				if(i<=0)
				{
					//oر LX O̥kI, RX O̥IӧP_O_ۥ
					Rx=WorldRow[0].startCol*bkgW[center]-sidePixels;
					Lx=(WorldRow[0].endCol+1)*bkgW[center]+sidePixels;
				}
				else
				{
					Lx=WorldRow[i-1].startCol*bkgW[center]+sidePixels;
					Rx=(WorldRow[i-1].endCol+1)*bkgW[center]-sidePixels;
				}

				if(*xc<=Lx || *xc>=Rx)
				{
					if(*y2==*yc) *y2=*yc+SpringD;
					else *y2=2*(*yc)-*y2; //*y2=*y2;
					blHitted=true; debugID=36; break;							
				}						
			}
		}		
	 }
  }	


  //NIb Cu(tCuW)
  if(*xc>x1) *xc-=sidePixels;//(sidePixels*2);
  else if(*xc<x1)*xc+=sidePixels;//(sidePixels*2);

  if(*yc>y1) *yc-=sidePixels;//(sidePixels*2);
  else if(*yc<y1)*yc+=sidePixels;//(sidePixels*2);

  /*
  curReflectionLevel++;
  if (curReflectionLevel<MaxReflectionNum)
  {
	//DIϮgI world sII@sϮgI  
	int oldx2=*x2, oldy2=*y2;
	HitWorldEdge(*xc, *yc, &oldx2, &oldy2, x2, y2);
	//NIb Cu(tCuW)
	*x2=(*x2>*xc)?*x2-1:*x2+1;
	*y2=(*yc>*yc)?*y2-1:*y2+1;	
  }
  else
  {
	curReflectionLevel=0;	
  }
  */

  return blHitted;
}


//ھڵImeXI--------------------------------------------------------
bool CWorld2D::drawBackGround2Surface(LPDIRECTDRAWSURFACE lpSurface)
{
	int i, j;

	//pGIɤsb
	if (! (lpBkgSurface)) 
	{ 
		 MessageBox (NULL, "Failed!","lpBkgSurface=NULL", MB_OK);
	    return false;
	}


	short viewstartRow, viewendRow, viewstartCol, viewendCol;
   	RECT viewRect, srcBkgRect, srcSdRect, destBkgRect, destSdRect,
		 srcCnrRect, destCnrRect;
	
	//ù (ùyШt)
	viewRect.left  = 0;				viewstartCol = ColOfXY(ScreenToWorldX(viewRect.left));
	viewRect.top   = 0;				viewendRow	 = RowOfXY(ScreenToWorldY(viewRect.top));
	viewRect.right = SCREEN_WIDTH;	viewendCol	 = ColOfXY(ScreenToWorldX(viewRect.right));
	viewRect.bottom= SCREEN_HEIGHT;	viewstartRow = RowOfXY(ScreenToWorldY(viewRect.bottom));

	//ù WI------------	
	//DrawSurfaceRect(lpSurface, viewRect, RGB(0,0,0));
	//ColorFillSurface(lpSurface, 1);
	

	//I (ùyШt)
	srcBkgRect.left	  = 0;
	srcBkgRect.right  = bkgW[center];
	srcBkgRect.top    = 0;
	srcBkgRect.bottom = bkgH[center];	

	//(ùyШt)
	srcSdRect.left	  = 0;
	srcSdRect.top     = 0;	
	
	//ŧiid򤺪 Ī " _lCB̫C M _lB̫C
	short validstartRow, validendRow, validstartCol, validendCol;

	//pid " Ī " _lC M ̫C
	validstartRow = (viewstartRow<0)?0:viewstartRow; 
	validendRow	  = (viewendRow>=RowNum)?(RowNum-1):viewendRow;		


	//eXid򤺪 Ҧ ĦC M Ħ
	for (i=validstartRow; i<=validendRow; i++) 
    {
		//p⦹C  " Ī " _l M ̫
		validstartCol = (viewstartCol<WorldRow[i].startCol)?WorldRow[i].startCol:viewstartCol;
		validendCol	  = (viewendCol>WorldRow[i].endCol)?WorldRow[i].endCol:viewendCol;
	
		//p⦹CbùW top, bottom
		destBkgRect.bottom	= WorldToScreenY(i*bkgH[center]);
		destBkgRect.top		= destBkgRect.bottom-bkgH[center];
						
		
		for (j=validstartCol; j<=validendCol; j++)
		{
			//e  Row, Col			
			destBkgRect.left	= WorldToScreenX(j*bkgW[center]);
			destBkgRect.right	= destBkgRect.left+bkgW[center];			
			lpSurface->Blt(&destBkgRect,lpBkgSurface[center],&srcBkgRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
			//DBLT_KEYSRCOVERRIDE or DDBLT_KEYDESTOVERRIDE


			//}leWU, WUϪӷe׳ۦP----------------------------------------- 
			srcSdRect.right=bkgW[top]; srcSdRect.bottom=bkgH[top]; 
			//srcSdRect.right=kbgW[bottom]; srcSdRect.bottom=kbgH[bottom]; //bottomϼeM],M top P

			// (row, col) bùWWUM I  left, right P
			destSdRect.left	= destBkgRect.left;  //ؼЦm left = ثeIϪ left
			destSdRect.right= destBkgRect.right; //ؼЦm right =ثeIϪ right

			if(i==0) 
			{   //eU	
				destSdRect.top		= destBkgRect.bottom; 	//ؼЦm top = ثeIϪ bottom				
				destSdRect.bottom	= destSdRect.top+bkgH[bottom];
				lpSurface->Blt(&destSdRect,lpBkgSurface[bottom],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			

				//AeW
				if ((j<WorldRow[i+1].startCol)||(j>WorldRow[i+1].endCol)) //pGWbWCǤ~
				{					
					destSdRect.bottom	= destBkgRect.top; //ؼЦm bottom = ثeIϪ top
					destSdRect.top		= destSdRect.bottom-bkgH[top]; 	
					lpSurface->Blt(&destSdRect,lpBkgSurface[top],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
				}
			}
			else if(i==RowNum-1)
			{
				//eW		
				destSdRect.bottom	= destBkgRect.top; //ؼЦm bottom = ثeIϪ top
				destSdRect.top		= destSdRect.bottom-bkgH[top]; 	
				lpSurface->Blt(&destSdRect,lpBkgSurface[top],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
				
				//AeU
				if ((j<WorldRow[i-1].startCol)||(j>WorldRow[i-1].endCol)) //pGWbWCǤ~
				{								
					destSdRect.top		= destBkgRect.bottom; 	//ؼЦm top = ثeIϪ bottom				
					destSdRect.bottom	= destSdRect.top+bkgH[bottom];
					lpSurface->Blt(&destSdRect,lpBkgSurface[bottom],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
				}
			}
			else
			{
				//eU
				if (i>viewstartRow) //b Row AFĤ@Ci Row (viewstartRow)~AlneU
				if ((j<WorldRow[i-1].startCol)||(j>WorldRow[i-1].endCol)) //pGWbWCǤ~
				{					
					destSdRect.top		= destBkgRect.bottom; 	//ؼЦm top = ثeIϪ bottom				
					destSdRect.bottom	= destSdRect.top+bkgH[bottom];
					lpSurface->Blt(&destSdRect,lpBkgSurface[bottom],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
				}
				//eW
				if (i<viewendRow)//b Row AF̫Ci Row (viewendRow)~AlneU
				if ((j<WorldRow[i+1].startCol)||(j>WorldRow[i+1].endCol)) //pGWbWCǤ~
				{
					destSdRect.bottom	= destBkgRect.top; //ؼЦm bottom = ثeIϪ top
					destSdRect.top		= destSdRect.bottom-bkgH[top]; 	
					lpSurface->Blt(&destSdRect,lpBkgSurface[top],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
				}
			}			
		}
		
		//eCk, kϪtop, bottom MCIϪ top, bottom ۦP
		destSdRect.top	= destBkgRect.top;	destSdRect.bottom = destBkgRect.bottom;
		//C	
		if (viewstartCol<WorldRow[i].startCol)
		{
			srcSdRect.right	 = bkgW[left];	srcSdRect.bottom= bkgH[left]; //Ϩӷe
			destSdRect.left  = WorldToScreenX(validstartCol*bkgW[center])-bkgW[left]; //ϥتù left, right
			destSdRect.right = destSdRect.left+bkgW[left]; 				
			lpSurface->Blt(&destSdRect,lpBkgSurface[left],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
			
			//WUӨ
			srcCnrRect.left=srcCnrRect.top=0;
			srcCnrRect.right=bkgW[corner135]; srcCnrRect.bottom=bkgH[corner135];
			//ؼ left, right M ϦPA
			destCnrRect.left	= destSdRect.left;
			destCnrRect.right	= destSdRect.right;
			//eU Corner225
			if (i>viewstartRow) //b Row AFĤ@Ci Row (viewstartRow)~AlneU
			if ((i==0)||(WorldRow[i].startCol<WorldRow[i-1].startCol)) 
			{							 					
				destCnrRect.top		= destSdRect.bottom;
				destCnrRect.bottom	= destCnrRect.top+bkgH[corner225];
				lpSurface->Blt(&destCnrRect,lpBkgSurface[corner225],&srcCnrRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
			}
			//eW
			if (i<viewendRow)//b Row AF̫Ci Row (viewendRow)~AlneU
			if ((i==RowNum-1)||(WorldRow[i].startCol<WorldRow[i+1].startCol) )
			{				
				destCnrRect.bottom	= destSdRect.top; 	//ؼЦm top = ثeIϪ bottom				
				destCnrRect.top		= destCnrRect.bottom-bkgH[corner135];
				lpSurface->Blt(&destCnrRect,lpBkgSurface[corner135],&srcCnrRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
			}
		}

		//Ck
		if (viewendCol>WorldRow[i].endCol)
		{
			srcSdRect.right	 = bkgW[right];	srcSdRect.bottom= bkgH[right]; //Ϩӷe
			destSdRect.left  = WorldToScreenX((validendCol+1)*bkgW[center]); //ϥتù left, right
			destSdRect.right = destSdRect.left+bkgW[right]; 			
			lpSurface->Blt(&destSdRect,lpBkgSurface[right],&srcSdRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			

			//kWUӨ
			srcCnrRect.left=srcCnrRect.top=0;
			srcCnrRect.right=bkgW[corner45]; srcCnrRect.bottom=bkgH[corner45];
			//ؼ left, right M ϦPA
			destCnrRect.left	= destSdRect.left;
			destCnrRect.right	= destSdRect.right;
			//ekU corner315
			if (i>viewstartRow) //b Row AFĤ@Ci Row (viewstartRow)~AlneU
			if ((i==0)||(WorldRow[i].endCol>WorldRow[i-1].endCol)) 
			{							 					
				destCnrRect.top		= destSdRect.bottom;
				destCnrRect.bottom	= destCnrRect.top+bkgH[corner315];
				lpSurface->Blt(&destCnrRect,lpBkgSurface[corner315],&srcCnrRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
			}
			//ekW
			if (i<viewendRow)//b Row AF̫Ci Row (viewendRow)~AlneU
			if ((i==RowNum-1)||(WorldRow[i].endCol>WorldRow[i+1].endCol)) 
			{				
				destCnrRect.bottom	= destSdRect.top; 	//ؼЦm top = ثeIϪ bottom				
				destCnrRect.top		= destCnrRect.bottom-bkgH[corner45];
				lpSurface->Blt(&destCnrRect,lpBkgSurface[corner45],&srcCnrRect,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
			}
		}
	} 

	//eYpa
	/*//e World Map  lpSecSurface-------------------------------------------------
	int mx=SCREEN_WIDTH/2-WorldToMapX(ViewX),
		my=SCREEN_HEIGHT/2-WorldToMapY(ViewY);
	if(ShowMap) DrawMap2Surface(lpSurface, mx, my);*/


    return true;	
}

//Ǧ^ XY b World ҦbC----------------------------------------------
short CWorld2D::RowOfXY(int y)
{ 
   if (!WorldRow) return 0;

   if (y>=0)	 
     return  y/bkgH[center];	//  (x, y) Ҧb Row No.
   else
	 return  y/bkgH[center]-1;
}

//Ǧ^ XY b World ҦbC----------------------------------------------
short CWorld2D::ColOfXY(int x)
{ 
   if (!WorldRow) return 0;

   if (x>=0)
     return x/bkgW[center];	//  (x, y) Ҧb Row No.
   else
	 return x/bkgW[center]-1;
}



// World X yùy---------------------------------------------------------
int CWorld2D::WorldToScreenX(int x)
{
  return (x-ViewX)+(SCREEN_WIDTH/2);
}

// Worlyùy---------------------------------------------------------
int CWorld2D::WorldToScreenY(int y)
{
  return (SCREEN_HEIGHT/2)-(y-ViewY);
}

// Worlyùy---------------------------------------------------------
int CWorld2D::ScreenToWorldX(int x)
{
  return ViewX+(x-SCREEN_WIDTH/2);
}

// Worlyùy---------------------------------------------------------
int CWorld2D::ScreenToWorldY(int y)
{
  return ViewY-(y-SCREEN_HEIGHT/2);
}


// b World İϰ줺H@y---------------------------------------------------------
void CWorld2D::GetRandomPosInWorld(int *x, int *y)
{
  short irow, icol;

  if (!WorldRow) return;

  // Random @ӦĪ RowNo.
  irow=Random.number(0, RowNum-1);

  //bĪ Row  Random Ī Col
  icol=Random.number(WorldRow[irow].startCol,WorldRow[irow].endCol);

  //bĪ Row, Col  Random X@ծy
  *y=Random.number(irow*bkgH[center]+10, (irow+1)*bkgH[center]-10);
  *x=Random.number(icol*bkgW[center]+10, (icol+1)*bkgW[center]-10);
}

// Ǧ^ World  `C-----------------------------------------------------------------
short CWorld2D::WorldRowNum()
{
  return RowNum;
}

// Ǧ^ World  `C-----------------------------------------------------------------
short CWorld2D::WorldColNum()
{
  return ColNum;
}

// Ǧ^ World  `C-----------------------------------------------------------------
RowRec CWorld2D::StartEndColInRow(int row)
{
  return WorldRow[row];
}


// eYpa-------------------------------------------------------------------------
bool CWorld2D::DrawMap2Surface(LPDIRECTDRAWSURFACE lpSurface, int x, int y, bool Solid) //eYpa
{  
  if (!lpSurface) return false;
  /*
  RECT destRect;  

  destRect.left=x; destRect.top=y;
  destRect.right=destRect.left+MapW; destRect.bottom=destRect.top+MapH;

  lpSurface->Blt(&destRect,lpMapSurface,NULL,DDBLT_KEYSRC|DDBLT_WAIT,NULL);			
  */

  
  unsigned short ptnum=RowNum*4+1;
  POINT *tmppt=0;   

  tmppt=new POINT[ptnum];
  for(int i=0; i<ptnum; i++)
  { tmppt[i].x=x+MapPt[i].x; tmppt[i].y=y+MapPt[i].y;}  

  if(Solid)
	DrawSurfacePolygon(lpSurface, tmppt, RowNum*4, MapColor);
  else
    DrawSurfacePolyline(lpSurface, tmppt, RowNum*4+1, MapColor);
  

  //eXViewX, ViewY 
  //int mx=WorldToMapX(ViewX), my=WorldToMapY(ViewY);
  //DrawSurfaceEllipse(lpSurface, mx+x,my+y,4,RGB(255,255,255));

  delete [] tmppt;

  return true;  
}


// eYpa-------------------------------------------------------------------------
bool CWorld2D::DrawWorldMap2MapSurface() //eYpa
{      
  if (!lpMapSurface) return false; 

  ColorFillSurface(lpMapSurface, TRANSPARENT_COLOR); 

  DrawSurfacePolygon(lpMapSurface, MapPt, RowNum*4, MapColor);  
  //DrawSurfacePolyline(lpMapSurface, MapPt, RowNum*4+1, MapColor); 
 
  return true;
}

// Alpha Blend Map---------------------------------------------------------------
bool CWorld2D::BlendDrawMap2Surface(LPDIRECTDRAWSURFACE lpSurface, int x, int y)
{
	if (!lpSurface) return false;

	
	int BlendW=MapW, BlendH=MapH;
	
	/*
	RECT srcRect;
    srcRect.left=x; srcRect.top=y;
	srcRect.right=srcRect.left+BlendW;
	srcRect.bottom=srcRect.top+BlendH;
	//Nت lpSurface ϥe lpMapSurface
	lpMapSurface->BltFast(0,0,lpSurface,&srcRect,DDBLTFAST_WAIT);

	//AsWaϨ lpMapSurface
    DrawSurfacePolygon(lpMapSurface, MapPt, RowNum*4, MapColor);
	*/
	
	//ANs lpMapSurface e lpSurface W
	int destx,desty,destw, desth, srcx,srcy,srcw,srch;
	destx=x;//(SCREEN_WIDTH-BlendW)/2;
	desty=y;//(SCREEN_HEIGHT-BlendH)/2;
	destw=BlendW;
	desth=BlendH;
	srcx=0;  srcy=0;  srcw=BlendW;  srch=BlendH;	
	//BlendSurface(lpSurface, destx, desty, destw, desth, lpMapSurface, 
	//			 srcx, srcy, srcw, srch, 150);
	CBlendSurface(lpSurface,destx,desty,lpMapSurface,srcw,srch);

	/*//eXDm
	int mx=WorldToMapX(ViewX), my=WorldToMapY(ViewY);
    DrawSurfaceEllipse(lpSurface, mx+x,my+y,3,RGB(255,0,0));*/




	/*//AsWaϨ lpMapSurface
	//DrawWorldMap2MapSurface();
   
	//}l-------------------------------------------------------------
	DDSURFACEDESC ddsd; //direct draw surface descriptor
	BYTE *dest;
	int i,Alpha=1;

	//lock down surface
	if(FAILED(lpMapSurface->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL)))
    return FALSE;
	
	dest=(BYTE*)ddsd.lpSurface; //destination pointer
	int ddw=ddsd.lPitch, ix, iy;  
  
	for(i=0; i<ddw*MapH; i+=(Alpha+1))
	{
		iy=i/ddw;

		if((i%ddw)<MapW)
		memset(&dest[i], TRANSPARENT_COLOR, 1);	
		else 
		{ ix=Random.number(0,Alpha); i=(iy+1)*ddw+ix;}
	}
	//clean up and return
    lpMapSurface->Unlock(NULL);
	
	RECT rect; rect.left=x; rect.top=y; rect.right=x+MapW; rect.bottom=x+MapH;

	lpSurface->Blt(&rect,lpMapSurface,NULL,DDBLT_KEYSRC|DDBLT_WAIT,NULL);*/


	return true;
}

// World X ylpMapSurfaceùy------------------------------------------------
int CWorld2D::WorldToMapX(int x)
{
	return int(MapResolution*x+MapSidePixel);
}

// World Y ylpMapSurfaceùy-------------------------------------------
int CWorld2D::WorldToMapY(int y)
{
	return int(MapH-MapResolution*y-MapSidePixel);
}





