//bmp.cpp: member functions for the bmp file reader
//Daniel CopyRight Reserved December, 5, 2001



#include "bmp.h" //header file
#include "Random.h"


extern CRandom Random;



//*************************************************************************************

//*************************** CBmpFileREader Class ************************************

//*************************************************************************************

//constructors------------------------------------------------------------------------ 
CBmpFileReader::CBmpFileReader()
{ 
  ImageData=0; //NϧθƩҦbЪl NULL
}

//destructors --------------------------------------------------------------------
CBmpFileReader::~CBmpFileReader()
{ 
  delete[] ImageData; //reclaim memory from image data
}


//member functions

//Ūɨ----------------------------------------------------------------------
BOOL CBmpFileReader::load(char *filename)
{ 
  HANDLE hfile;		// handle
  DWORD actualRead; //ŪJ Byte 
  int image_size;	//ɤjpŶ (width*height)
  BOOL OK=TRUE;		//sʧ@PO Flag

  //}ɷǳŪJ
  hfile=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,
	  (LPSECURITY_ATTRIBUTES)NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,(HANDLE)NULL);
  //pG}ɥѫhX
  if(hfile==INVALID_HANDLE_VALUE)return FALSE;
  //ŪJɪ Head O BmpFileHead 
  OK=ReadFile(hfile,&BMPFileHead,sizeof(BMPFileHead), &actualRead,NULL);
  //ŪJɪ Infomation O BmpFileInfo 
  if(OK)OK=ReadFile(hfile,&BMPFileInfo, sizeof(BMPFileInfo),&actualRead,NULL);

  //TwŪJ BitȬO_PGamewqۦP
  if(OK)OK=BMPFileInfo.biBitCount==GameCOLOR_DEPTH;
  //}lŪJLƨO PalData[]
  if(OK)OK=ReadFile(hfile,PaletteData,sizeof(PaletteData), &actualRead,NULL);
  //pGѶǦ^ False
  if(!OK){CloseHandle(hfile); return FALSE;}
  //ھFileInfoɪeưtmtmɪŶ
  image_size=BMPFileInfo.biWidth*BMPFileInfo.biHeight;
  if(ImageData)delete[]ImageData; //pGwƥ
  ImageData=new BYTE[image_size]; //tmϧθƪŶ
  if(!ImageData) { CloseHandle(hfile); return FALSE;}

  //oɤƪCe (BmpɳCe׬ 4 )
  // BMPFileInfo.biWidth Oɼe׬ϧΪĹڼe

  int width=(BMPFileInfo.biWidth+3)&~3; //o 4 ƪ width, ɤƼe  
  
  BYTE trash[4]; //sLĪϧθ
  int garbageW=width-BMPFileInfo.biWidth; //width of trash
    
  //}lŪJϧθ
  for (int i=0; i<BMPFileInfo.biHeight; i++)
  {
    //ŪJCĸ
    OK=OK&&ReadFile(hfile,(BYTE*)(ImageData+i*BMPFileInfo.biWidth),BMPFileInfo.biWidth,&actualRead,NULL);
    //ŪJCѤULĸ
    OK=OK&&ReadFile(hfile,trash,garbageW,&actualRead,NULL);

	if (!OK) break;
  }

  if(!OK)delete[]ImageData; 

  //ɮ
  CloseHandle(hfile);
  return OK;
} //load


//ƻsɾƨ Surface --------------------------------------------------
BOOL CBmpFileReader::draw2Surface(LPDIRECTDRAWSURFACE lpsurface)
{ 
  DDSURFACEDESC ddsd; //direct draw surface descriptor
  BYTE *dest,*src; //destination and source pointers
  int src_width; //width of source

  //NSurface descriptor Ҧƪl0
  memset(&ddsd,0,sizeof(DDSURFACEDESC));
  ddsd.dwSize=sizeof(ddsd);

  //ت Surface OаϡAȮɤ\L{sC
  if(FAILED(lpsurface->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL))) return FALSE;

  //wتSurfaceaϧθưϪ}lm
  dest=(BYTE*)ddsd.lpSurface; //destination

  //wӷ (CBmpFileReader) ϧθưϪ_l}C
  //]ӷϧθƲĤ@COڹϧΪ̫@CAҥHݱq̫@C}lƻs
  src=ImageData+((BMPFileInfo.biHeight-1)*BMPFileInfo.biWidth);

  //pGӷϪeפjSurfacee ( byte), hH Surfacee׬D
  if(BMPFileInfo.biWidth>ddsd.lPitch)src_width=ddsd.lPitch;
  else src_width=BMPFileInfo.biWidth;
  
  //}lƻs
  for(int i=0; i<BMPFileInfo.biHeight; i++)
  {
    memcpy(dest,src,src_width);
    dest+=ddsd.lPitch; src-=src_width;
  }

  //]wLiνd  
  DDCOLORKEY ddck;
  ddck.dwColorSpaceHighValue=230;
  ddck.dwColorSpaceLowValue=1;
  lpsurface->SetColorKey(DDCKEY_SRCBLT,&ddck);
    

  //w
  lpsurface->Unlock(NULL);
  return TRUE;
} //draw


//--------------------------------------------------------------
BOOL CBmpFileReader::AlphaDraw2Surface(LPDIRECTDRAWSURFACE lpsurface, BYTE Alpha)
{
  DDSURFACEDESC ddsd; //direct draw surface descriptor
  BYTE *dest,*src; //destination and source pointers
  int src_width; //width of source

  //NSurface descriptor Ҧƪl0
  memset(&ddsd,0,sizeof(DDSURFACEDESC));
  ddsd.dwSize=sizeof(ddsd);

  //ت Surface OаϡAȮɤ\L{sC
  if(FAILED(lpsurface->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL))) return FALSE;

  //wتSurfaceaϧθưϪ}lm
  dest=(BYTE*)ddsd.lpSurface; //destination

  //wӷ (CBmpFileReader) ϧθưϪ_l}C
  //]ӷϧθƲĤ@COڹϧΪ̫@CAҥHݱq̫@C}lƻs
  src=ImageData+((BMPFileInfo.biHeight-1)*BMPFileInfo.biWidth);

  //pGӷϪeפjSurfacee ( byte), hH Surfacee׬D
  if(BMPFileInfo.biWidth>ddsd.lPitch)src_width=ddsd.lPitch;
  else src_width=BMPFileInfo.biWidth;
  
  //}lƻs
  for(int i=0; i<BMPFileInfo.biHeight; i++)
  {
    memcpy(dest,src,src_width);
    dest+=ddsd.lPitch; src-=src_width;
  }

  //]wLiνd  
  DDCOLORKEY ddck;
  ddck.dwColorSpaceHighValue=230;
  ddck.dwColorSpaceLowValue=1;
  lpsurface->SetColorKey(DDCKEY_SRCBLT,&ddck);
  

  //}l-------------------------------------------------------------
  BYTE Level=255;
  Alpha%=Level;

  dest=(BYTE*)ddsd.lpSurface; //destination pointer
  int h=BMPFileInfo.biHeight, w=BMPFileInfo.biWidth, ddw=ddsd.lPitch, 
	  steps=Level-Alpha,n=Level/steps,count=0,restw=ddw-w;
	  
    
  for(i=0; i<ddw*h; i+=Level)
  {
	for(int j=0; j<steps; j++)
	{
		count=i+j*n;
		if((count%ddw)<w) dest[count]=TRANSPARENT_COLOR;
		else {i+=restw; count=i+j*n; dest[count]=TRANSPARENT_COLOR;}
	}
  }

  //w
  lpsurface->Unlock(NULL);
  return TRUE;
}


//NLJYLЫVLŶ--------------------------------------
BOOL CBmpFileReader::setSurfacePalette(LPDIRECTDRAWPALETTE lppalette)
{
  PALETTEENTRY pe[GameCOLORS]; //intermediate palette

  if(!lppalette) return FALSE;
  //construct pe[]
  for(int i=0; i<GameCOLORS; i++)
  { 
    pe[i].peRed=PaletteData[i].rgbRed; //set red
    pe[i].peGreen=PaletteData[i].rgbGreen; //set green
    pe[i].peBlue=PaletteData[i].rgbBlue; //set blue
  }
  //load direct draw palette to surface
  lppalette->SetEntries(NULL,0,GameCOLORS,pe);
  return TRUE;
}


//Ǧ^ɼe-----------------------------------------------------------
int CBmpFileReader::ImageWidth()
{
  return BMPFileInfo.biWidth;
}

//Ǧ^ɰ-----------------------------------------------------------
int CBmpFileReader::ImageHeight()
{
  return BMPFileInfo.biHeight;
}

//Ǧ^LYӧǸC
COLORREF CBmpFileReader::GetPaletteColor(int i)
{
   if(i<0 ||  i>GameCOLORS) return RGB(0,0,0);

   return RGB(PaletteData[i].rgbRed, PaletteData[i].rgbGreen, PaletteData[i].rgbBlue);
}







//*************************************************************************************

//*************************** CBmpSpriteFileREader Class ******************************

//*************************************************************************************


//ƻsɳƨ Surface --------------------------------------------------
BOOL CBmpSpriteFileReader::draw2Surface(LPDIRECTDRAWSURFACE lpsurface, int w,int h,int x,int y)
{
  DDSURFACEDESC ddsd; //direct draw surface descriptor
  BYTE *dest,*src; //destination and source pointers
  
  //init surface descriptor
  memset(&ddsd,0,sizeof(DDSURFACEDESC));
  ddsd.dwSize=sizeof(ddsd);
  
  //lock down surface
  if(FAILED(lpsurface->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL)))
    return FALSE;

  //calculate addresses and width
  dest=(BYTE*)ddsd.lpSurface; //destination pointer
  src=ImageData+ //source pointer
    ((BMPFileInfo.biHeight-1-y)*BMPFileInfo.biWidth+x);
  
  //move data to surface
  for(int i=0; i<h; i++)
  { //for each row
    memcpy(dest,src,w); //copy
    dest+=ddsd.lPitch; src-=BMPFileInfo.biWidth; //next row
  }

  //clean up and return
  lpsurface->Unlock(NULL);

  return TRUE;
} 

//CX Pixel e Surface W------------------------------------------------
BOOL CBmpSpriteFileReader::AlphaDraw2Surface(LPDIRECTDRAWSURFACE lpsurface, 
			int w, int h, int x, int y, BYTE Alpha)
{

  DDSURFACEDESC ddsd; //direct draw surface descriptor
  BYTE *dest,*src; //destination and source pointers
  
  //init surface descriptor
  memset(&ddsd,0,sizeof(DDSURFACEDESC));
  ddsd.dwSize=sizeof(ddsd);
  
  //lock down surface
  if(FAILED(lpsurface->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL)))
    return FALSE;

  //calculate addresses and width
  dest=(BYTE*)ddsd.lpSurface; //destination pointer
  src=ImageData+ //source pointer
    ((BMPFileInfo.biHeight-1-y)*BMPFileInfo.biWidth+x);
  
  //move data to surface
  for(int i=0; i<h; i++)
  { //for each row
    memcpy(dest,src,w); //copy
    dest+=ddsd.lPitch; src-=BMPFileInfo.biWidth; //next row
  }


  //}l-------------------------------------------------------------
  BYTE Level=255;
  Alpha=Alpha%Level;

  dest=(BYTE*)ddsd.lpSurface; //destination pointer
  int ddw=ddsd.lPitch, steps=Level-Alpha,n=Level/steps,count=0,restw=ddw-w;
    
  for(i=0; i<ddw*h; i+=Level)
  {
	for(int j=0; j<steps; j++)
	{
		count=i+j*n;
		if((count%ddw)<w) dest[count]=TRANSPARENT_COLOR;
		else {i+=restw; count=i+j*n; dest[count]=TRANSPARENT_COLOR;}
	}
  }

  //clean up and return
  lpsurface->Unlock(NULL);

  return TRUE;
}