//ddrawUtil.cpp 
//Daniel CopyRight Reserved December, 12, 2001

//\G
//1)  b DirectDrawSurface We

//system includes


//custom includes
#include "ddrawUtil.h"


//~ܼ
extern unsigned char AlphaTable[256][256];


//----------------------------------------------------------------------------------
//b DirectDrawSurface We Rectangle
bool DrawSurfaceRect(LPDIRECTDRAWSURFACE lpSurface, RECT rect, COLORREF color)
{
	HDC hdc;
	HBRUSH hBrush;

	hBrush=CreateSolidBrush(color);

	lpSurface->GetDC(&hdc);
	SelectObject(hdc,hBrush);
	FillRect(hdc, &rect, hBrush);
	lpSurface->ReleaseDC(hdc);

	return true;
}


//----------------------------------------------------------------------------------
//b DirectDrawSurface We Polygon
bool DrawSurfacePolygon(LPDIRECTDRAWSURFACE lpSurface, POINT *pt, int ptNum, COLORREF color)
{
	HDC hdc;
	HBRUSH hBrush;
	//HPEN hPen;

	hBrush=CreateSolidBrush(color);
	//hPen=CreatePen(PS_SOLID, 2, color);
	//hBrush=CreateHatchBrush(HS_CROSS,color);

	lpSurface->GetDC(&hdc);
	SelectObject(hdc,hBrush);
	//SelectObject(hdc,hPen);
	Polygon(hdc, pt, ptNum);
	lpSurface->ReleaseDC(hdc);
	//DeleteObject(hBrush);
	//DeleteObject(hPen);

	return true;
}

//----------------------------------------------------------------------------------
//b DirectDrawSurface We PolylINE
bool DrawSurfacePolyline(LPDIRECTDRAWSURFACE lpSurface, POINT *pt, int ptNum, COLORREF color)
{
	HDC hdc;
	HPEN hPen;

	hPen=CreatePen(PS_SOLID, 1, color);

	lpSurface->GetDC(&hdc);
	SelectObject(hdc,hPen);
	Polyline(hdc, pt, ptNum);
	lpSurface->ReleaseDC(hdc);
	DeleteObject(hPen);

	return true;
}


//b DirectDrawSurface We Ellipse
bool DrawSurfaceEllipse(LPDIRECTDRAWSURFACE lpSurface, int cx, int cy, int r, COLORREF color)
{
	HDC hdc;
	HBRUSH hBrush;
	HPEN hPen;
	int x1=cx-r, y1=cy-r, x2=cx+r, y2=cy+r;

	hBrush=CreateSolidBrush(color);
	hPen=CreatePen(PS_SOLID, 2, color);

	lpSurface->GetDC(&hdc);
	SelectObject(hdc,hBrush);
	SelectObject(hdc,hPen);
	Ellipse(hdc,x1,y1,x2,y2);
	lpSurface->ReleaseDC(hdc);

	DeleteObject(hBrush);
	DeleteObject(hPen);

	return true;
}

//----------------------------------------------------------------------------------
//b DirectDrawSurface We Rectangle
bool BlendSurface(LPDIRECTDRAWSURFACE lpSurfaceDest, int destx,int desty,int destw,int desth, 
				  LPDIRECTDRAWSURFACE lpSurfaceSrc, int srcx, int srcy, int srcw, int srch,
				  unsigned char srcAlpha)
{
	HDC hdcDest, hdcSrc;
	BLENDFUNCTION BlendF;

	memset(&BlendF,0,sizeof(BlendF));
	BlendF.SourceConstantAlpha=srcAlpha;

	lpSurfaceDest->GetDC(&hdcDest);
	lpSurfaceSrc->GetDC(&hdcSrc);

	AlphaBlend(hdcDest,destx, desty, destw, desth,
			   hdcSrc,srcx, srcy, srcw, srch,BlendF);


	lpSurfaceDest->ReleaseDC(hdcDest);
	lpSurfaceSrc->ReleaseDC(hdcSrc);

	return true;
}

//Alpha Blend ϥ  AlphaTable---------------------------------------------------------
bool CBlendSurface(LPDIRECTDRAWSURFACE lpSurfaceDest, int destx,int desty, 
				  LPDIRECTDRAWSURFACE lpSurfaceSrc, int srcw, int srch)
{
	DDSURFACEDESC src_ddsd,dest_ddsd; //direct draw surface descriptor
	BYTE *dest,*src; //destination and source pointers
	
	src_ddsd.dwSize=sizeof(src_ddsd);
	dest_ddsd.dwSize=sizeof(dest_ddsd);

	//ӷMت Surface OаϡAȮɤ\L{sC
	if(FAILED(lpSurfaceSrc->Lock(NULL,&src_ddsd, DDLOCK_WAIT,NULL))) return FALSE;
	if(FAILED(lpSurfaceDest->Lock(NULL,&dest_ddsd,DDLOCK_WAIT,NULL))) return FALSE;
	
	src=(BYTE*) src_ddsd.lpSurface;
	dest=(BYTE*)dest_ddsd.lpSurface; //destination pointer
	int i, j, cursrcPos=0, curdestPos, ddw=dest_ddsd.lPitch,ddwsrc=src_ddsd.lPitch;


	for(j=desty; j<desty+srch; j++)
	{		
		for(i=destx; i<destx+srcw; i++)	
		{
			curdestPos=j*ddw+i;
			if(src[cursrcPos]==TRANSPARENT_COLOR);
			else
			  dest[curdestPos]=AlphaTable[src[cursrcPos]][dest[curdestPos]];
			cursrcPos++;
		}

		cursrcPos=cursrcPos+(ddwsrc-srcw);
	}


	//w
	lpSurfaceSrc->Unlock(NULL);
	lpSurfaceDest->Unlock(NULL);

	return true;
}

//----------------------------------------------------------------------------------
//N Surface񺡬YC
bool ColorFillSurface(LPDIRECTDRAWSURFACE lpSurface, unsigned short palleteID)
{
	DDBLTFX ddbltfx;

	// Use the blter to do a color fill to clear the back buffer
	//ZeroMemory(&ddbltfx, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = palleteID;
	lpSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);

	return true;
}







/*  Direct Draw Tips***************************************************************************************

//1) zK----------------------------------------------------------------------

	Add the color key flags for Bltfast and Blt :

	Bltfast :	DDBLTFAST_SRCCOLORKEY and /or DDBLTFAST_DESTCOLORKEY flags 
				in the dwTrans parameter.
	Blt		:	DBLT_KEYSRCOVERRIDE or DDBLT_KEYDESTOVERRIDE flag, or both, 
				in the dwFlags parameters.

//2) o Pixel -----------------------------------------------------------------

	HDC hdc;surface->GetDC(&hdc);
	COLORREF clr = GetPixel(hdc,4,6);
	surface->ReleaseDC(hdc);  

*/