//Effect.cpp: member functions for the Effect.h
//Daniel CopyRight Reserved December, 26, 2001



//system includes

//custom includes
#include "Effect.h"
#include "Random.h"
#include "WorldSystem.h"
#include "ddrawUtil.h"


//~ܼ----------------------------------------------------------------------
extern CRandom Random;
extern CWorld2D GameWorld;
extern RECT ScreenRECT;
extern PALETTEENTRY ParticlePalette[256];


CFire::CFire()
{	
	pFire=NULL;
}

CFire::~CFire()
{
	delete[] pFire;
}


void CFire::Create(int x, int y, int R, int pfires)
{
	if(pFire) delete[] pFire;

	pFireNum=pfires;
	pFire=new CParticle[pFireNum];	

	curX=x; curY=y;
	Radious=R;	
	
	for(int i=0; i<pFireNum; i++)
	  //pFire[i].Create(curX,curY);
	  pFire[i].Create(Random.number(curX-Radious, curX+Radious),Random.number(curY-Radious, curY+Radious));
}

void CFire::Wave()
{
	curX=GameWorld.ViewX;
	curY=GameWorld.ViewY;

	for(int i=0; i<pFireNum; i++)
	{
		pFire[i].Move();

		if(pFire[i].Life<=0) //pGFAsA
		{
			/*
			pFire[i].Life=1.0;
			pFire[i].curX=curX;
			pFire[i].curY=curY;*/

			pFire[i].Create(Random.number(curX-Radious, curX+Radious),
					  Random.number(curY-Radious, curY+Radious));
		}
	}	
}


BOOL CFire::Draw2Surface(LPDIRECTDRAWSURFACE lpDestSurface)
{
	int i, palID, size=5;
	POINT scrpt;
	HDC hdc;
	COLORREF color;
	HBRUSH hBrush[256];
	HPEN hPen[256];

	for(i=0; i<256; i++) 
	{
		color=RGB(ParticlePalette[i].peRed,	ParticlePalette[i].peGreen,	
					  ParticlePalette[i].peBlue);
		hBrush[i]=CreateSolidBrush(color);
		hPen[i]=CreatePen(PS_SOLID, 2, color);
		
	}

	lpDestSurface->GetDC(&hdc);
	
	for (i=0; i<pFireNum; i++)
	{
		scrpt.x=GameWorld.WorldToScreenX(pFire[i].curX);//Random.number(0, SCREEN_WIDTH);//
		scrpt.y=GameWorld.WorldToScreenY(pFire[i].curY);//Random.number(0, SCREEN_HEIGHT);//

		if(PtInRect(&ScreenRECT, scrpt))
		{
			palID=int(pFire[i].Life*255);
			size=palID>>5;  // >>5 = H32, hjp̤j 255/32=8, ̤p 0/255=0; 
			
			SelectObject(hdc,hBrush[palID]);
			SelectObject(hdc,hPen[palID]);
			
			Ellipse(hdc,scrpt.x-size, scrpt.y-size, scrpt.x+size, scrpt.y+size);		
		}				
	}

	for(i=0; i<256; i++) {DeleteObject(hBrush[i]); DeleteObject(hPen[i]);}

	lpDestSurface->ReleaseDC(hdc);
		
	/*
	DDSURFACEDESC dest_ddsd; //direct draw surface descriptor
	BYTE *dest; //destination and source pointers
		
	dest_ddsd.dwSize=sizeof(dest_ddsd);

	//ӷMت Surface OаϡAȮɤ\L{sC	
	if(FAILED(lpDestSurface->Lock(NULL,&dest_ddsd,DDLOCK_WAIT,NULL))) return FALSE;	
	
	dest=(BYTE*)dest_ddsd.lpSurface; //destination pointer
	int curdestPos, ddw=dest_ddsd.lPitch;		

	
	for (i=0; i<pFireNum; i++)
	{
		scrpt.x=GameWorld.WorldToScreenX(pFire[i].curX);//Random.number(0, SCREEN_WIDTH);//
		scrpt.y=GameWorld.WorldToScreenY(pFire[i].curY);//Random.number(0, SCREEN_HEIGHT);//

		if(PtInRect(&ScreenRECT, scrpt))
		{
			curdestPos=scrpt.y*ddw+scrpt.x;
			color=int(pFire[i].Life*255);
			dest[curdestPos]=color;
		}		
	}

	//w
	lpDestSurface->Unlock(NULL);*/
	

	return TRUE;
}